class AdminRolesBean {
  bool status;
  int statusCode;
  String message;
  List<RoleListBean> data;

  AdminRolesBean({this.status, this.statusCode, this.message, this.data});

  AdminRolesBean.fromJson(dynamic json) {
    status = json["status"];
    statusCode = json["status_code"];
    message = json["message"];
    if (json["data"] != null) {
      data = [];
      json["data"].forEach((v) {
        data.add(RoleListBean.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    map["status"] = status;
    map["status_code"] = statusCode;
    map["message"] = message;
    if (data != null) {
      map["data"] = data.map((v) => v.toJson()).toList();
    }
    return map;
  }
}

class RoleListBean {
  int id;
  String roleName;
  String status;
  dynamic createdAt;
  dynamic updatedAt;

  RoleListBean(
      {this.id, this.roleName, this.status, this.createdAt, this.updatedAt});

  RoleListBean.fromJson(dynamic json) {
    id = json["id"];
    roleName = json["role_name"];
    status = json["status"];
    createdAt = json["created_at"];
    updatedAt = json["updated_at"];
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    map["id"] = id;
    map["role_name"] = roleName;
    map["status"] = status;
    map["created_at"] = createdAt;
    map["updated_at"] = updatedAt;
    return map;
  }
}
