class ModuleDetailsBean {
  bool status;
  int statusCode;
  String message;
  List<ModuleDetailListBean> data;

  ModuleDetailsBean({this.status, this.statusCode, this.message, this.data});

  ModuleDetailsBean.fromJson(dynamic json) {
    status = json["status"];
    statusCode = json["status_code"];
    message = json["message"];
    if (json["data"] != null) {
      data = List<ModuleDetailListBean>.empty(growable: true);
      json["data"].forEach((v) {
        data.add(ModuleDetailListBean.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    map["status"] = status;
    map["status_code"] = statusCode;
    map["message"] = message;
    if (data != null) {
      map["data"] = data.map((v) => v.toJson()).toList();
    }
    return map;
  }
}

class ModuleDetailListBean {
  int id;
  String moduleName;
  String moduleIcon;
  String status;
  dynamic createdAt;
  dynamic updatedAt;
  List<Screen> screen;

  ModuleDetailListBean(
      {this.id,
      this.moduleName,
      this.moduleIcon,
      this.status,
      this.createdAt,
      this.updatedAt,
      this.screen});

  ModuleDetailListBean.fromJson(dynamic json) {
    id = json["id"];
    moduleName = json["module_name"];
    moduleIcon = json["module_icon"];
    status = json["status"];
    createdAt = json["created_at"];
    updatedAt = json["updated_at"];
    if (json["screen"] != null) {
      screen = List<Screen>.empty(growable: true);
      json["screen"].forEach((v) {
        screen.add(Screen.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    map["id"] = id;
    map["module_name"] = moduleName;
    map["module_icon"] = moduleIcon;
    map["status"] = status;
    map["created_at"] = createdAt;
    map["updated_at"] = updatedAt;
    if (screen != null) {
      map["screen"] = screen.map((v) => v.toJson()).toList();
    }
    return map;
  }
}

class Screen {
  int id;
  int moduleId;
  String screenName;
  String screenIcon;
  String status;
  dynamic createdAt;
  dynamic updatedAt;

  Screen(
      {this.id,
      this.moduleId,
      this.screenName,
      this.screenIcon,
      this.status,
      this.createdAt,
      this.updatedAt});

  Screen.fromJson(dynamic json) {
    id = json["id"];
    moduleId = json["module_id"];
    screenName = json["screen_name"];
    screenIcon = json["screen_icon"];
    status = json["status"];
    createdAt = json["created_at"];
    updatedAt = json["updated_at"];
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    map["id"] = id;
    map["module_id"] = moduleId;
    map["screen_name"] = screenName;
    map["screen_icon"] = screenIcon;
    map["status"] = status;
    map["created_at"] = createdAt;
    map["updated_at"] = updatedAt;
    return map;
  }
}
