class ProjectDetailsBean {
  bool status;
  int statusCode;
  String message;
  List<ProjectListBean> data;

  ProjectDetailsBean({this.status, this.statusCode, this.message, this.data});

  ProjectDetailsBean.fromJson(dynamic json) {
    status = json["status"];
    statusCode = json["status_code"];
    message = json["message"];
    if (json["data"] != null) {
      data = [];
      json["data"].forEach((v) {
        data.add(ProjectListBean.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    map["status"] = status;
    map["status_code"] = statusCode;
    map["message"] = message;
    if (data != null) {
      map["data"] = data.map((v) => v.toJson()).toList();
    }
    return map;
  }
}

class ProjectListBean {
  int id;
  String projectName;
  int projectRelease;
  int assignFrom;
  int user;
  String projectApplication;
  String projectDescription;
  String projectCode;
  String date;
  int projectStatus;
  int ownerId;
  String createdAt;
  String updatedAt;

  ProjectListBean(
      {this.id,
      this.projectName,
      this.projectRelease,
      this.assignFrom,
      this.user,
      this.projectApplication,
      this.projectDescription,
      this.projectCode,
      this.date,
      this.projectStatus,
      this.ownerId,
      this.createdAt,
      this.updatedAt});

  ProjectListBean.fromJson(dynamic json) {
    id = json["id"];
    projectName = json["project_name"];
    projectRelease = json["project_release"];
    assignFrom = json["assign_from"];
    user = json["user"];
    projectApplication = json["project_application"];
    projectDescription = json["project_description"];
    projectCode = json["project_code"];
    date = json["date"];
    projectStatus = json["project_status"];
    ownerId = json["owner_id"];
    createdAt = json["created_at"];
    updatedAt = json["updated_at"];
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    map["id"] = id;
    map["project_name"] = projectName;
    map["project_release"] = projectRelease;
    map["assign_from"] = assignFrom;
    map["user"] = user;
    map["project_application"] = projectApplication;
    map["project_description"] = projectDescription;
    map["project_code"] = projectCode;
    map["date"] = date;
    map["project_status"] = projectStatus;
    map["owner_id"] = ownerId;
    map["created_at"] = createdAt;
    map["updated_at"] = updatedAt;
    return map;
  }
}
