class DealsBean {
  bool status;
  int statusCode;
  String message;
  List<DealListBean> dealListBean;

  DealsBean({this.status, this.statusCode, this.message, this.dealListBean});

  DealsBean.fromJson(Map<String, dynamic> json) {
    status = json['status'];
    statusCode = json['status_code'];
    message = json['message'];
    if (json['dealListBean'] != null) {
      dealListBean = new List<DealListBean>();
      json['dealListBean'].forEach((v) {
        dealListBean.add(new DealListBean.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['status'] = this.status;
    data['status_code'] = this.statusCode;
    data['message'] = this.message;
    if (this.dealListBean != null) {
      data['dealListBean'] = this.dealListBean.map((v) => v.toJson()).toList();
    }
    return data;
  }
}

class DealListBean {
  int id;
  Companyid companyid;
  Contactid contactid;
  Statusid statusid;
  String name;
  String desc;
  int probability;
  int dealcost;
  String closingdate;
  OwnerId ownerId;
  String createdAt;
  String updatedAt;

  DealListBean(
      {this.id,
        this.companyid,
        this.contactid,
        this.statusid,
        this.name,
        this.desc,
        this.probability,
        this.dealcost,
        this.closingdate,
        this.ownerId,
        this.createdAt,
        this.updatedAt});

  DealListBean.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    companyid = json['companyid'] != null
        ? new Companyid.fromJson(json['companyid'])
        : null;
    contactid = json['contactid'] != null
        ? new Contactid.fromJson(json['contactid'])
        : null;
    statusid = json['statusid'] != null
        ? new Statusid.fromJson(json['statusid'])
        : null;
    name = json['name'];
    desc = json['desc'];
    probability = json['probability'];
    dealcost = json['dealcost'];
    closingdate = json['closingdate'];
    ownerId = json['owner_id'] != null
        ? new OwnerId.fromJson(json['owner_id'])
        : null;
    createdAt = json['created_at'];
    updatedAt = json['updated_at'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    if (this.companyid != null) {
      data['companyid'] = this.companyid.toJson();
    }
    if (this.contactid != null) {
      data['contactid'] = this.contactid.toJson();
    }
    if (this.statusid != null) {
      data['statusid'] = this.statusid.toJson();
    }
    data['name'] = this.name;
    data['desc'] = this.desc;
    data['probability'] = this.probability;
    data['dealcost'] = this.dealcost;
    data['closingdate'] = this.closingdate;
    if (this.ownerId != null) {
      data['owner_id'] = this.ownerId.toJson();
    }
    data['created_at'] = this.createdAt;
    data['updated_at'] = this.updatedAt;
    return data;
  }
}

class Companyid {
  int id;
  String companyname;
  String email;
  int phone;
  String website;
  int industry;
  int annualrevenue;
  int noofemployees;
  String area;
  String address1;
  String address2;
  String state;
  int pincode;
  String country;
  int ownerId;
  int statusid;
  String createdAt;
  String updatedAt;

  Companyid(
      {this.id,
        this.companyname,
        this.email,
        this.phone,
        this.website,
        this.industry,
        this.annualrevenue,
        this.noofemployees,
        this.area,
        this.address1,
        this.address2,
        this.state,
        this.pincode,
        this.country,
        this.ownerId,
        this.statusid,
        this.createdAt,
        this.updatedAt});

  Companyid.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    companyname = json['companyname'];
    email = json['email'];
    phone = json['phone'];
    website = json['website'];
    industry = json['industry'];
    annualrevenue = json['annualrevenue'];
    noofemployees = json['noofemployees'];
    area = json['area'];
    address1 = json['address1'];
    address2 = json['address2'];
    state = json['state'];
    pincode = json['pincode'];
    country = json['country'];
    ownerId = json['owner_id'];
    statusid = json['statusid'];
    createdAt = json['created_at'];
    updatedAt = json['updated_at'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['companyname'] = this.companyname;
    data['email'] = this.email;
    data['phone'] = this.phone;
    data['website'] = this.website;
    data['industry'] = this.industry;
    data['annualrevenue'] = this.annualrevenue;
    data['noofemployees'] = this.noofemployees;
    data['area'] = this.area;
    data['address1'] = this.address1;
    data['address2'] = this.address2;
    data['state'] = this.state;
    data['pincode'] = this.pincode;
    data['country'] = this.country;
    data['owner_id'] = this.ownerId;
    data['statusid'] = this.statusid;
    data['created_at'] = this.createdAt;
    data['updated_at'] = this.updatedAt;
    return data;
  }
}

class Contactid {
  int id;
  int accountid;
  String firstname;
  String secondName;
  String email;
  int mobile;
  int phone;
  String dept;
  String title;
  String area;
  String address1;
  String address2;
  String state;
  int statusid;
  int ownerId;
  String createdAt;
  String updatedAt;

  Contactid(
      {this.id,
        this.accountid,
        this.firstname,
        this.secondName,
        this.email,
        this.mobile,
        this.phone,
        this.dept,
        this.title,
        this.area,
        this.address1,
        this.address2,
        this.state,
        this.statusid,
        this.ownerId,
        this.createdAt,
        this.updatedAt});

  Contactid.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    accountid = json['accountid'];
    firstname = json['firstname'];
    secondName = json['secondName'];
    email = json['email'];
    mobile = json['mobile'];
    phone = json['phone'];
    dept = json['dept'];
    title = json['title'];
    area = json['area'];
    address1 = json['address1'];
    address2 = json['address2'];
    state = json['state'];
    statusid = json['statusid'];
    ownerId = json['owner_id'];
    createdAt = json['created_at'];
    updatedAt = json['updated_at'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['accountid'] = this.accountid;
    data['firstname'] = this.firstname;
    data['secondName'] = this.secondName;
    data['email'] = this.email;
    data['mobile'] = this.mobile;
    data['phone'] = this.phone;
    data['dept'] = this.dept;
    data['title'] = this.title;
    data['area'] = this.area;
    data['address1'] = this.address1;
    data['address2'] = this.address2;
    data['state'] = this.state;
    data['statusid'] = this.statusid;
    data['owner_id'] = this.ownerId;
    data['created_at'] = this.createdAt;
    data['updated_at'] = this.updatedAt;
    return data;
  }
}

class Statusid {
  int id;
  String page;
  String key;
  String name;
  String status;
  String desc;
  String createdAt;
  String updatedAt;

  Statusid(
      {this.id,
        this.page,
        this.key,
        this.name,
        this.status,
        this.desc,
        this.createdAt,
        this.updatedAt});

  Statusid.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    page = json['page'];
    key = json['key'];
    name = json['name'];
    status = json['status'];
    desc = json['desc'];
    createdAt = json['created_at'];
    updatedAt = json['updated_at'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['page'] = this.page;
    data['key'] = this.key;
    data['name'] = this.name;
    data['status'] = this.status;
    data['desc'] = this.desc;
    data['created_at'] = this.createdAt;
    data['updated_at'] = this.updatedAt;
    return data;
  }
}

class OwnerId {
  int id;
  String uid;
  String fcmids;
  String name;
  String email;
  int phone;
  String photourl;
  int roleid;
  String status;
  String createdAt;
  String updatedAt;

  OwnerId(
      {this.id,
        this.uid,
        this.fcmids,
        this.name,
        this.email,
        this.phone,
        this.photourl,
        this.roleid,
        this.status,
        this.createdAt,
        this.updatedAt});

  OwnerId.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    uid = json['uid'];
    fcmids = json['fcmids'];
    name = json['name'];
    email = json['email'];
    phone = json['phone'];
    photourl = json['photourl'];
    roleid = json['roleid'];
    status = json['status'];
    createdAt = json['created_at'];
    updatedAt = json['updated_at'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['uid'] = this.uid;
    data['fcmids'] = this.fcmids;
    data['name'] = this.name;
    data['email'] = this.email;
    data['phone'] = this.phone;
    data['photourl'] = this.photourl;
    data['roleid'] = this.roleid;
    data['status'] = this.status;
    data['created_at'] = this.createdAt;
    data['updated_at'] = this.updatedAt;
    return data;
  }
}
