class ModuleBean {
  bool status;
  int statusCode;
  String message;
  Data data;

  ModuleBean({this.status, this.statusCode, this.message, this.data});

  ModuleBean.fromJson(dynamic json) {
    status = json["status"];
    statusCode = json["status_code"];
    message = json["message"];
    data = json["data"] != null ? Data.fromJson(json["data"]) : null;
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    map["status"] = status;
    map["status_code"] = statusCode;
    map["message"] = message;
    if (data != null) {
      map["data"] = data.toJson();
    }
    return map;
  }
}

class Data {
  List<Modules> modules;
  List<Screens> screens;

  Data({this.modules, this.screens});

  Data.fromJson(dynamic json) {
    if (json["modules"] != null) {
      modules = [];
      json["modules"].forEach((v) {
        modules.add(Modules.fromJson(v));
      });
    }
    if (json["screens"] != null) {
      screens = [];
      json["screens"].forEach((v) {
        screens.add(Screens.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    if (modules != null) {
      map["modules"] = modules.map((v) => v.toJson()).toList();
    }
    if (screens != null) {
      map["screens"] = screens.map((v) => v.toJson()).toList();
    }
    return map;
  }
}

class Screens {
  int id;
  int moduleId;
  String screenName;
  String screenIcon;
  String status;
  dynamic createdAt;
  dynamic updatedAt;
  int permissionStr;

  Screens(
      {this.id,
      this.moduleId,
      this.screenName,
      this.screenIcon,
      this.status,
      this.createdAt,
      this.updatedAt,
      this.permissionStr});

  @override
  String toString() {
    return 'Screens{id: $id, moduleId: $moduleId, screenName: $screenName, screenIcon: $screenIcon, status: $status, createdAt: $createdAt, updatedAt: $updatedAt, permissionStr: $permissionStr}';
  }

  Screens.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    moduleId = json['module_id'];
    screenName = json['screen_name'];
    screenIcon = json['screen_icon'];
    status = json['status'];
    createdAt = json['created_at'];
    updatedAt = json['updated_at'];
    permissionStr = json['permission_str'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['module_id'] = this.moduleId;
    data['screen_name'] = this.screenName;
    data['screen_icon'] = this.screenIcon;
    data['status'] = this.status;
    data['created_at'] = this.createdAt;
    data['updated_at'] = this.updatedAt;
    data['permission_str'] = this.permissionStr;
    return data;
  }
}

class Modules {
  int id;
  String moduleName;
  String moduleIcon;
  String status;
  dynamic createdAt;
  dynamic updatedAt;

  Modules(
      {this.id,
      this.moduleName,
      this.moduleIcon,
      this.status,
      this.createdAt,
      this.updatedAt});

  Modules.fromJson(dynamic json) {
    id = json["id"];
    moduleName = json["module_name"];
    moduleIcon = json["module_icon"];
    status = json["status"];
    createdAt = json["created_at"];
    updatedAt = json["updated_at"];
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    map["id"] = id;
    map["module_name"] = moduleName;
    map["module_icon"] = moduleIcon;
    map["status"] = status;
    map["created_at"] = createdAt;
    map["updated_at"] = updatedAt;
    return map;
  }
}
