import 'dart:convert';
import 'dart:io' as Io;
import 'dart:typed_data';
import 'package:example/Constants/AppColors.dart';
import 'package:example/Constants/AppStrings.dart';
import 'package:example/Constants/fontFamily.dart';
import 'package:example/Constants/server_url.dart';
import 'package:example/Models/Admin/module_details_bean.dart';
import 'package:example/Models/base_bean.dart';
import 'package:example/Utils/Loader.dart';
import 'package:example/Utils/Utility.dart';
import 'package:example/network/api_service.dart';
import 'package:bui_component/ButtonsComponent/buttonComponent.dart';
import 'package:bui_component/Constants/fontSize.dart';
import 'package:file_picker/file_picker.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:toast/toast.dart';

class AddScreen extends StatefulWidget {
  AddScreen({
    Key key,
    this.primaryColor,
    this.secondaryColor,
    this.screen,
    this.onCallBack,
  });

  Color primaryColor;
  Color secondaryColor;
  List<Screen> screen;
  Function() onCallBack;

  @override
  _AddScreenState createState() => _AddScreenState();
}

class _AddScreenState extends State<AddScreen> {
  String fileName;
  String path;
  Map<String, String> paths;
  List<String> extensions;
  bool isLoadingPath = false;
  bool isMultiPick = false;
  FileType fileType = FileType.image;

  final fileNameController = TextEditingController();
  final nameController = TextEditingController();
  var _formKey = GlobalKey<FormState>();

  bool isLoader = false;

  Uint8List _byteImage;

  bool isShow = false;

  Uint8List showImage;

  Image image;

  void _openFileExplorer() async {
    setState(() => isLoadingPath = true);
    try {
      path = await FilePicker.getFilePath(
          type: fileType != null ? fileType : FileType.any,
          allowedExtensions: extensions);
      paths = null;

      fileNameController.text = path;

      final bytes = await Io.File(path).readAsBytes();
      String img64 = base64Encode(bytes);

      path = img64;
      print(img64.substring(0, 100));
      print(img64);
      if(bytes!=null) {
        //_byteImage = Base64Decoder().convert(img64);

        showImage = base64.decode(img64);

        Uint8List _image = base64Decode(img64);
        image = Image.memory(_image);

        print(_byteImage);

        print(showImage.toString());
        if(_byteImage==null){
          setState(() {
            isShow = true;
          });

        }
        else{
          setState(() {
            isShow = false;
          });
        }
      }

    } on PlatformException catch (e) {
      print("Unsupported operation" + e.toString());
    }
    if (!mounted) return;
    setState(() {
      isLoadingPath = false;
      fileName = path != null
          ? path.split('/').last
          : paths != null
              ? paths.keys.toString()
              : '...';
    });
  }

  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    // fileType = FileType.any;
  }

  @override
  Widget build(BuildContext context) {
    return new Scaffold(
      appBar: new AppBar(
        title: const Text('File Picker example app'),
      ),
      body: isLoader
          ? isLoaderView
          : Center(
              child: new Padding(
              padding: const EdgeInsets.only(left: 10.0, right: 10.0),
              child: Form(
                key: _formKey,
                child: new SingleChildScrollView(
                  child: new Column(
                    mainAxisAlignment: MainAxisAlignment.start,
                    children: <Widget>[
                      _buildTextView("Screen Name"),
                      Container(
                        padding: const EdgeInsets.all(8),
                        margin: EdgeInsets.only(
                            top: 5, bottom: 2, left: 8, right: 8),
                        child: TextFormField(
                          controller: nameController,
                          decoration: new InputDecoration(
                            filled: true,
                            fillColor: Colors.white,
                            hintText: "Screen Name",
                            enabledBorder: OutlineInputBorder(
                              borderRadius: BorderRadius.circular(5.0),
                              borderSide: BorderSide(
                                color: widget.primaryColor,
                                width: 1.0,
                              ),
                            ),
                            focusedBorder: OutlineInputBorder(
                              borderRadius: BorderRadius.circular(5.0),
                              borderSide: BorderSide(
                                color: widget.primaryColor,
                              ),
                            ),
                            contentPadding: const EdgeInsets.all(5.0),
                            border: OutlineInputBorder(
                              borderRadius: BorderRadius.circular(5.0),
                            ),
                          ),
                          validator: (value) {
                            if (value.length == 0) {
                              return "Please Enter Some Text";
                            }
                            return null;
                          },
                          onChanged: (String value) {},
                          onFieldSubmitted: (value) {
                            Utils.hideKeyboard(context);
                          },
                        ),
                      ),
                      _buildTextView("File Selection"),
                      Container(
                        padding: const EdgeInsets.all(8),
                        margin: EdgeInsets.only(
                            top: 5, bottom: 2, left: 8, right: 8),
                        child: TextFormField(
                          onTap: () {
                            Utils.hideKeyboard(context);
                            _openFileExplorer();
                          },
                          controller: fileNameController,
                          decoration: new InputDecoration(
                            filled: true,
                            fillColor: Colors.white,
                            hintText: "File Selector",
                            enabledBorder: OutlineInputBorder(
                              borderRadius: BorderRadius.circular(5.0),
                              borderSide: BorderSide(
                                color: widget.primaryColor,
                                width: 1.0,
                              ),
                            ),
                            focusedBorder: OutlineInputBorder(
                              borderRadius: BorderRadius.circular(5.0),
                              borderSide: BorderSide(
                                color: widget.primaryColor,
                              ),
                            ),
                            contentPadding: const EdgeInsets.all(5.0),
                            border: OutlineInputBorder(
                              borderRadius: BorderRadius.circular(5.0),
                            ),
                          ),
                          validator: (value) {
                            if (value.length == 0) {
                              return "Please Enter Some Text";
                            }
                            return null;
                          },
                          onChanged: (String value) {},
                          onFieldSubmitted: (value) {
                            Utils.hideKeyboard(context);
                          },
                        ),
                      ),
                      Visibility(
                        visible: isShow,
                        child: Container(
                          height: 100,
                          child: image,
                        ),
                      ),
                      Container(
                          margin: EdgeInsets.only(
                              top: 5, bottom: 2, left: 16, right: 20),
                          child: Row(
                            mainAxisAlignment: MainAxisAlignment.spaceAround,
                            children: [
                              Button.mini(
                                width: MediaQuery.of(context).size.width * 0.3,
                                onPressed: () {
                                  Navigator.of(context).pop();
                                },
                                buttonSize: ButtonSize.medium,
                                buttonType: ButtonType.custom,
                                btnColor: AppColors.APP_BUTTON_GREY,
                                btnTextColor: widget.primaryColor,
                                btnText: AppStrings.CANCEL,
                                elevation: 10,
                              ),
                              Button.mini(
                                width: MediaQuery.of(context).size.width * 0.3,
                                onPressed: () {
                                  final isValid =
                                      _formKey.currentState.validate();
                                  if (!isValid) {
                                    return;
                                  } else {
                                    if (path.isNotEmpty &&
                                        nameController.text.isNotEmpty) {
                                      callScreenAddedAPI();
                                    } else {
                                      Toast.show(
                                          "Required All Fields", context);
                                    }
                                  }

                                  _formKey.currentState.save();
                                },
                                buttonSize: ButtonSize.medium,
                                buttonType: ButtonType.custom,
                                btnColor: widget.secondaryColor ??
                                    AppColors.APP_COLOR_PRIMARY,
                                btnTextColor: Colors.white,
                                btnText: AppStrings.SAVE,
                                elevation: 10,
                              ),
                            ],
                          ))
                    ],
                  ),
                ),
              ),
            )),
    );
  }

  Widget _buildTextView(String label) {
    return Container(
        width: MediaQuery.of(context).size.width,
        margin: EdgeInsets.only(top: 5, left: 16, right: 20),
        child: RichText(
          text: TextSpan(
            text: label,
            style: TextStyle(
                fontSize: FontSize.FONT_18,
                fontFamily: FontFamily.Gilroy,
                fontWeight: FontWeight.bold,
                color: widget.primaryColor ?? AppColors.primaryColor),
            children: const <TextSpan>[
              TextSpan(
                  text: ' *',
                  style: TextStyle(
                      fontWeight: FontWeight.bold,
                      color: AppColors.errorWarning)),
            ],
          ),
        ));
  }

  Widget get isLoaderView {
    if (isLoader) {
      return Center(
        child: Loader(
          loaderColor: widget.primaryColor,
        ),
      );
    } else {
      return Container();
    }
  }

  Future<void> callScreenAddedAPI() async {
    setState(() {
      isLoader = true;
    });

    String urlController = ServerUrl.screenCreate;

    var objToSend = {
      "\"module_id\"": "\"${widget.screen[0].moduleId.toString()}\"",
      "\"screen_icon\"": "\"${path.toString()}\"",
      "\"screen_name\"": "\"${nameController.text}\"",
      "\"${UrlParams.AID}\"": "\"${UrlParams.AID_VALUE}\"",
      "\"${UrlParams.AKEY}\"": "\"${UrlParams.AKEY_VALUE}\"",
      "\"${UrlParams.AV}\"": "\"${UrlParams.AV_VALUE}\"",
    };

    String jsonStr = objToSend.toString();

    String res = await APIClient.getInstance().callAPI(
        context, urlController, HTTPMethod.POST,
        isHeader: true, requestBody: jsonStr);
    Map map = jsonDecode(res);

    BaseResponse baseResponse = BaseResponse.fromJson(map);
    if(baseResponse.status){

      setState(() {
        isLoader = false;
        widget.onCallBack();
        Navigator.pop(context);
      });

    }
  }
}
