

import 'package:example/Constants/AppColors.dart';
import 'package:example/Constants/AppStrings.dart';
import 'package:example/Models/Admin/module_details_bean.dart';
import 'package:example/Utils/Loader.dart';
import 'package:bui_component/CardComponent/cardComponent.dart';
import 'package:flutter/material.dart';
import 'package:transition/transition.dart';


import 'AddScreen.dart';

class ViewScreen extends StatefulWidget {
  ViewScreen(
      {Key key,
      this.primaryColor,
      this.secondaryColor,
      this.onCallBack,
      this.screens,
      this.visible,
      this.permissionStr});

  Color primaryColor;
  Color secondaryColor;
  Function() onCallBack;
  List<Screen> screens;
  bool visible;
  int permissionStr;

  @override
  _ViewScreenState createState() => _ViewScreenState();
}

class _ViewScreenState extends State<ViewScreen> {
  bool isLoader = false;

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text("Screen Name"),
      ),
      body: isLoader
          ? Stack(
              children: [
                isLoaderView,
              ],
            )
          : Stack(
              children: [deleteDetailsView, detailsView],
            ),
      floatingActionButton: Visibility(
        visible: true ?? widget.visible,
        child: FloatingActionButton(
          mini: true,
          onPressed: () {
            Navigator.push(
                context,
                Transition(
                    child: AddScreen(
                      primaryColor: widget.primaryColor,
                      secondaryColor: widget.secondaryColor,
                      screen:widget.screens,
                      onCallBack: (){
                        widget.onCallBack();
                        Navigator.pop(context);
                      },

                    ),
                    transitionEffect: TransitionEffect.RIGHT_TO_LEFT));
          },
          child: const Icon(Icons.add),
          backgroundColor: widget.secondaryColor,
        ),
      ),
    );
  }

  Widget get deleteDetailsView {
    return Container(
      height: 30,
      //
      width: MediaQuery.of(context).size.width,
      alignment: Alignment.center,
      child: Text(
        AppStrings.holdToDelete,
        style: TextStyle(fontSize: 14, color: Colors.black87),
      ),
      color: Colors.grey[400],
    );
  }

  Widget get isLoaderView {

    return Center(
      child: Loader(
        loaderColor: widget.primaryColor,
      ),
    );
  }

  Widget get detailsView {
    return Container(
      height: MediaQuery.of(context).size.height * 0.8,
      margin: EdgeInsets.only(top: 35),
      child: ListView.builder(
          itemCount: widget.screens.length,
          itemBuilder: (BuildContext ctx, index) {
            return BUICard.imageWithTextCard(
              isVisible: true,
              cardText: widget.screens[index].screenName,
              //cardText: moduleName[index].moduleName.length > 0 ?'${moduleName[index].moduleName[0].toUpperCase()}${moduleName[index].moduleName.substring(1)}':'',
              cardTextColor: AppColors.primaryColor,
              cardType: CardType.cardWithImageAndText,
              sourceImage: AppStrings.vegImage,
              cardColor: widget.primaryColor,
              isEnabled:
                  widget.screens[index].status == "active" ? true : false,
              isGrid: false,
              height: 100,
            );
          }),
    );
  }
}
