import 'dart:convert';

import 'package:bui_component/CardComponent/cardComponent.dart';
import 'package:bui_component/Constants/AppColors.dart';
import 'package:bui_component/Constants/AppStrings.dart';
import 'package:bui_component/Constants/fontSize.dart';
import 'package:bui_component/JsonFormComponent/json_schema.dart';
import 'package:example/Constants/server_url.dart';
import 'package:example/Models/account_details_bean.dart';
import 'package:example/Models/base_bean.dart';
import 'package:example/Models/contact_details_bean.dart';
import 'package:example/Models/deals_details_bean.dart';
import 'package:example/Models/details_bean.dart';
import 'package:example/Models/notes_details_bean.dart';
import 'package:example/Models/task_detail_bean.dart';
import 'package:example/Utils/Utility.dart';
import 'package:example/Utils/loader.dart';
import 'package:example/Utils/logger.dart';
import 'package:example/network/api_service.dart';
import 'package:flutter/material.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:transition/transition.dart';

import '../../main.dart';
import '../platform.dart';
import 'CreateNoteScreen.dart';
import 'CreateTaskScreen.dart';

class DealScrenViewDetails extends StatefulWidget {
  String pageTitle;
  String dateTime;
  String currency;
  String email;
  String firstName;
  String type;
  Color primaryColor;
  Color secondaryColor;
  int id;
  Function() onCallBack;

  DealsListDetailsBean dealListBean;
  int permissionStr;
  bool visible;
  String ownerId;

  DealScrenViewDetails(
      {this.pageTitle,
      this.dateTime,
      this.currency,
      this.email,
      this.firstName,
      this.type,
      this.primaryColor,
      this.secondaryColor,
      this.id,
      this.onCallBack,
      this.dealListBean,
      this.permissionStr,
      this.visible,
      this.ownerId});

  @override
  DealScrenViewDetailsState createState() => DealScrenViewDetailsState();
}

class DealScrenViewDetailsState extends State<DealScrenViewDetails> {
  Color primaryColor = AppColors.APP_COLOR_PRIMARY;
  Color secondaryColor;

  SharedPreferences prefs;

  bool isLoader = true;

  String jsonFormFilterData;

  List<dynamic> companyName = List<dynamic>.empty(growable: true);

  List<dynamic> contactName = List<dynamic>.empty(growable: true);

  String dateTime;
  String currency;
  var now = DateTime.now();

  bool isLoading = true;

  ScrollController _scrollController = new ScrollController();
  int startIndex = 0;
  int offset = 10;

  bool visible = true;

  List<ContactListBean> contactListBeanData =
      new List<ContactListBean>.empty(growable: true);

  final GlobalKey<ScaffoldState> _scaffoldKey = new GlobalKey<ScaffoldState>();

  int indexValue;

  bool showFloating = false;

  List<TaskDetailList> taskListBeanData = new List.empty(growable: true);
  NotesDetailsBean notesDetailsBean;
  List<NotesListDetailsBean> notesListDetailsBean =
      new List.empty(growable: true);

  dynamic formGeneral;

  List<dynamic> status = new List.empty(growable: true);

  String form;

  dynamic response;
  Map keyBoardTypes = {
    'number': TextInputType.number,
    'text': TextInputType.text,
    'email': TextInputType.emailAddress,
    'url': TextInputType.emailAddress,
  };

  List<String> taskName = ["Open", "Close"];

  bool flag = true;

  @override
  void initState() {
    accountScreenViewDetailsAPI();

    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return SafeArea(
      child: WillPopScope(
        onWillPop: () {
          Navigator.pop(context);
        },
        child: Scaffold(
          key: _scaffoldKey,
          appBar: widget.type == "Add"
              ? AppBar(
                  title: Text("Add Deals"),
                  backgroundColor: widget.primaryColor,
                )
              : null,
          body: widget.type != "Add"
              ? DefaultTabController(
                  length: 3,
                  child: NestedScrollView(
                      headerSliverBuilder:
                          (BuildContext context, bool innerBoxIsScrolled) {
                        return <Widget>[
                          SliverAppBar(
                            expandedHeight: 150.0,
                            floating: true,
                            pinned: true,
                            title: widget.type != "Add"
                                ? Text(
                                    widget.dealListBean.companyid.companyname)
                                : Text(widget.pageTitle),
                            /*Text(widget.accountListBeanData.companyname != null
                          ? widget.accountListBeanData.companyname
                          : widget.pageTitle),*/
                            backgroundColor: widget.primaryColor ??
                                AppColors.APP_COLOR_PRIMARY,
                            bottom: TabBar(
                              onTap: (index) {
                                indexValue = index;
                                if (index == 1) {
                                  setState(() {
                                    showFloating = true;
                                  });
                                } else if (index == 2) {
                                  setState(() {
                                    showFloating = true;
                                  });
                                } else {
                                  setState(() {
                                    showFloating = false;
                                  });
                                }
                              },
                              indicatorColor: widget.primaryColor ??
                                  AppColors.APP_COLOR_PRIMARY,
                              labelColor: Colors.black87,
                              unselectedLabelColor: Colors.grey,
                              tabs: [
                                Tab(
                                  child: Container(
                                    child: Text(
                                      AppStrings.dealInfo,
                                      style: TextStyle(
                                          color: AppColors.APP_COLOR_WHITE,
                                          fontSize: FontSize.FONT_15,
                                          fontWeight: FontWeight.bold),
                                    ),
                                  ),
                                ),
                                Tab(
                                  child: Container(
                                    child: Text(
                                      AppStrings.TASK,
                                      style: TextStyle(
                                          color: AppColors.APP_COLOR_WHITE,
                                          fontSize: FontSize.FONT_15,
                                          fontWeight: FontWeight.bold),
                                    ),
                                  ),
                                ),
                                Tab(
                                  child: Container(
                                    child: Text(
                                      AppStrings.NOTES,
                                      style: TextStyle(
                                          color: AppColors.APP_COLOR_WHITE,
                                          fontSize: FontSize.FONT_15,
                                          fontWeight: FontWeight.bold),
                                    ),
                                  ),
                                ),
                              ],
                            ),
                          ),
                        ];
                      },
                      body: isLoading
                          ? Center(
                              child: Loader(
                              loaderColor: widget.primaryColor,
                            ))
                          : TabBarView(
                              physics: NeverScrollableScrollPhysics(),
                              children: [
                                _formView,
                                RefreshIndicator(
                                    color: widget.primaryColor,
                                    onRefresh: () {
                                      //  return taskAPI();
                                    },
                                    child: _taskView),
                                RefreshIndicator(
                                    color: widget.primaryColor,
                                    onRefresh: () {
                                      //   return notesAPI();
                                    },
                                    child: _notesView),
                              ],
                            )),
                )
              : isLoading
                  ? Center(
                      child: Loader(
                        loaderColor: widget.primaryColor,
                    ))
                  : Container(child: _formView),
          floatingActionButton: showFloating
              ? Visibility(
                  visible: widget.visible,
                  child: FloatingActionButton(
                    mini: true,
                    onPressed: () {
                      if (indexValue == 1) {
                        Navigator.push(
                            context,
                            Transition(
                                child: CreateTaskScreen(
                                  id: widget.id.toString(),
                                  primaryColor: widget.primaryColor,
                                  secondaryColor: widget.secondaryColor,
                                  //   onCallBack: onTaskAPICall,
                                  fromPageId: 'accountid',
                                ),
                                transitionEffect:
                                    TransitionEffect.RIGHT_TO_LEFT));
                      } else {
                        Navigator.push(
                            context,
                            Transition(
                                child: CreateNoteScreen(
                                  id: widget.id.toString(),
                                  primaryColor: widget.primaryColor,
                                  secondaryColor: widget.secondaryColor,
                                  //     onCallBack: onNotesAPICall,
                                  fromPageId: 'accountid',
                                ),
                                transitionEffect:
                                    TransitionEffect.RIGHT_TO_LEFT));
                      }
                    },
                    child: const Icon(Icons.add),
                    backgroundColor: widget.primaryColor ?? Colors.green,
                  ))
              : null,
        ),
      ),
    );
  }

  Widget get _formView {
    return new ListView(
      children: [
        isLoading
            ? Center(
                child: Loader(
                loaderColor: widget.primaryColor,
              ))
            : Form(
                child: new Center(
                  child: new Column(children: <Widget>[
                    new JsonSchema(
                      primaryColor:
                          widget.primaryColor ?? AppColors.primaryColor,
                      secondaryColor:
                          widget.secondaryColor ?? AppColors.APP_COLOR_PRIMARY,
                      keyboardTypes: keyBoardTypes,
                      form: form,
                      onChanged: (dynamic response) {
                        this.response = response;
                      },
                      buttonText: widget.type == AppStrings.ADD
                          ? AppStrings.ADD
                          : AppStrings.SAVE,
                      actionSave: (data) {
                        Utils.hideKeyboard(context);
                        setState(() {
                          formGeneral = data;
                        });

                        if (widget.permissionStr ==
                                AppStrings.fullAccessForAll ||
                            widget.permissionStr ==
                                AppStrings.fullAccessForOwn) {
                          var jsonObj;
                          if (widget.type != "Add") {
                            jsonObj = {
                              for (int i = 0; i < data['fields'].length; i++)
                                json.encode(data['fields'][i]['apiKeyValue']
                                        .toString()):
                                    json.encode(
                                        data['fields'][i]['value'].toString())
                            };
                          } else {
                            jsonObj = {
                              for (int i = 0; i < data['fields'].length; i++)
                                json.encode(data['fields'][i]['apiKeyValue']
                                        .toString()):
                                    json.encode(
                                        data['fields'][i]['value'].toString()),
                              "\"${UrlParams.AID}\"":
                                  "\"${UrlParams.AID_VALUE}\"",
                              "\"${UrlParams.AKEY}\"":
                                  "\"${UrlParams.AKEY_VALUE}\"",
                              "\"${UrlParams.AV}\"":
                                  "\"${UrlParams.AV_VALUE}\"",
                            };
                          }
                          if (widget.type != "Add") {

                            Logger.logMessage(Log.INFO, "Update===="+jsonObj.toString());
                            dealUpdateAPI(jsonObj.toString());
                          } else {
                            Logger.logMessage(Log.INFO, "Add===="+jsonObj.toString());
                            dealCreateAPI(jsonObj.toString());
                          }
                        } else {
                          Utils.showInSnackBar(
                              _scaffoldKey, AppStrings.noAccess);
                        }
                      },
                      actionCancel: () {
                        Navigator.pop(context);
                      },
                      buttonSave: true,
                    ),
                  ]),
                ),
              ),
      ],
    );
  }

  Widget get _taskView {
    if (taskListBeanData.length != 0) {
      return ListView.builder(
        itemCount: taskName.length,
        itemBuilder: (_, index) {
          return ExpansionTile(
              title: Text(
                taskName[index].toString() == "Open"
                    ? "UpComing Task"
                    : taskName[index].toString() == "Close"
                        ? "Completed Task"
                        : taskName[index].toString(),
                style: TextStyle(
                    color: AppColors.APP_COLOR_BLACK,
                    fontSize: FontSize.FONT_17,
                    fontWeight: FontWeight.bold),
              ),
              children: [
                ...taskListBeanData.map((e) {
                  if (e.statusid.name == taskName[index]) {
                    return BUICard.taskCard(
                      cardStatus: e.activitytypeid.name,
                      cardDesc: e.desc,
                      cardDate: widget.dateTime == "dd-mm-yyyy" &&
                              widget.dateTime != null
                          ? "${MyApp.buiFormatter.buiDateTimeDDMMYYFormat(e.duedate)}" ??
                              ""
                          : "${MyApp.buiFormatter.buiDateTimeYYYYMMDDFormat(e.duedate)}" ??
                              "",
                      cardType: CardType.cardTask,
                      cardSize: CardSize.medium,
                      cardColor: Colors.white,
                      cardTextColor: Colors.black87,
                      width: MediaQuery.of(context).size.width,
                      padding: 5,
                      height: 140,
                      isActiveStatus: e.statusid.name == "Open" ? false : true,
                      shape: RoundedRectangleBorder(
                        borderRadius: BorderRadius.circular(5.0),
                      ),
                      elevation: 10,
                      secondaryColor: widget.secondaryColor,
                      onStateChange: () {
                        setState(() {
                          if (e.statusid.name == "Open") {
                            e.statusid.name = "Close";
                            Utils.showInSnackBar(
                                _scaffoldKey, "Move into Close state");
                          } else {
                            Utils.showInSnackBar(_scaffoldKey,
                                "You cannot change the task from the closed position to the open position. Please contact admin");
                          }
                        });
                      },
                    );
                  } else {
                    return Container();
                  }
                }).toList(),
              ]);
        },
      );
    } else {
      return Center(
        child: Container(
          child: Text(
            AppStrings.NO_TASK_AVAILABLE,
            style: TextStyle(
                color: AppColors.textColor,
                fontSize: FontSize.FONT_20,
                fontWeight: FontWeight.bold),
          ),
        ),
      );
    }
  }

  Widget get _notesView {
    if (notesListDetailsBean.length != 0) {
      return ListView.builder(
          padding: const EdgeInsets.all(8),
          itemCount: notesListDetailsBean.length,
          itemBuilder: (BuildContext context, int index) {
            return BUICard.notesCard(
              cardType: CardType.cardNotes,
              cardSize: CardSize.medium,
              cardColor: Colors.white,
              cardTextColor: Colors.black87,
              width: MediaQuery.of(context).size.width,
              padding: 2,
              height: 123,
              cardAuthor:
                  widget.dealListBean.companyid.companyname.toUpperCase(),
              cardDesc: notesListDetailsBean[index].desc,
              cardDate: widget.dateTime == "dd-mm-yyyy" &&
                      widget.dateTime != null
                  ? "${MyApp.buiFormatter.buiDateTimeDDMMYYFormat(notesListDetailsBean[index].updatedAt)}" ??
                      ""
                  : "${MyApp.buiFormatter.buiDateTimeYYYYMMDDFormat(notesListDetailsBean[index].updatedAt)}" ??
                      "",
              shape: RoundedRectangleBorder(
                borderRadius: BorderRadius.circular(5.0),
              ),
              elevation: 10,
              secondaryColor: widget.secondaryColor,
              flag: flag,
              onStateChange: () {
                setState(() {
                  flag = !flag;
                });
              },
            );

            /*return BUICard(
              cardType: CardType.customCard,
              cardText: notesListDetailsBean[index].desc.toString(),
              cardSize: CardSize.small,
              height: MediaQuery.of(context).size.height * 0.2,
              cardColor: Colors.white,
              elevation: 20,
              padding: 15,
              shape: RoundedRectangleBorder(
                borderRadius: BorderRadius.circular(15.0),
              ),
            );*/
          });
    } else {
      return Center(
        child: Container(
          child: Text(
            AppStrings.NO_NOTES_AVAILABLE,
            style: TextStyle(
                color: AppColors.textColor,
                fontSize: FontSize.FONT_20,
                fontWeight: FontWeight.bold),
          ),
        ),
      );
    }
  }

  Future<void> accountScreenViewDetailsAPI() async {
    setState(() {
      if (startIndex == 0)
        isLoader = true;
      else
        isLoading = true;
    });
    String urlController = ServerUrl.crmAccountViewDetails;

    var objToSend = {
      "\"condition\"": [],
      "\"${UrlParams.AID}\"": "\"${UrlParams.AID_VALUE}\"",
      "\"${UrlParams.AKEY}\"": "\"${UrlParams.AKEY_VALUE}\"",
      "\"${UrlParams.AV}\"": "\"${UrlParams.AV_VALUE}\"",
    };

    String jsonStr = objToSend.toString();

    String res = await APIClient.getInstance().callAPI(
        context, urlController, HTTPMethod.POST,
        isHeader: true, requestBody: jsonStr);
    Map map = jsonDecode(res);

    AccountDetailsBean accountDetailsResponseBean =
        AccountDetailsBean.fromJson(map);

    if (accountDetailsResponseBean.statusCode == 400) {
      setState(() {
        isLoader = true;
        MyPlatformState.isLoader = true;
      });

      MyApp.callLoginAPI(context);
    }

    if (startIndex == 0 && accountDetailsResponseBean.data == null) {
      setState(() {
        isLoader = true;
      });
    }
    if (accountDetailsResponseBean.status) {
      if (accountDetailsResponseBean.data != null)
        //  accountListBeanData.addAll(accountDetailsResponseBean.data);

        companyName = [
          for (int i = 0; i < accountDetailsResponseBean.data.length; i++)
            if (accountDetailsResponseBean.data[i].companyname != null)
              {
                'label':
                    accountDetailsResponseBean.data[i].companyname.toString(),
                'value': accountDetailsResponseBean.data[i].id.toString(),
              },
        ];

      final jsonList1 = companyName.map((item) => jsonEncode(item)).toList();

      final uniqueJsonList1 = jsonList1.toSet().toList();

      companyName = uniqueJsonList1.map((item) => jsonDecode(item)).toList();

      companyName.insert(0, {
        'label': '',
        'value': '',
      });

      setState(() {
        isLoader = true;
        isLoading = true;
      });
      contactScreenViewDetailsAPI();
    }
  }

  Future<void> contactScreenViewDetailsAPI() async {
    setState(() {
      if (startIndex == 0)
        isLoader = true;
      else
        isLoading = true;
    });
    String urlController = ServerUrl.crmContactViewDetails;
    var objToSend = {
      "\"condition\"": [],
      /* "\"page\"": {
        "\"orderby\"": [
          {
            "\"id\"": "\"${"asc"}\"",
          }
        ],
        "\"no\"": "\"${startIndex.toString()}\"",
        "\"size\"": "\"${10}\"",
      },*/
      "\"${UrlParams.AID}\"": "\"${UrlParams.AID_VALUE}\"",
      "\"${UrlParams.AKEY}\"": "\"${UrlParams.AKEY_VALUE}\"",
      "\"${UrlParams.AV}\"": "\"${UrlParams.AV_VALUE}\"",
    };

    String jsonStr = objToSend.toString();

    String res = await APIClient.getInstance().callAPI(
        context, urlController, HTTPMethod.POST,
        isHeader: true, requestBody: jsonStr);
    Map map = jsonDecode(res);

    ContactDetailsBean contactDetailsResponseBean =
        ContactDetailsBean.fromJson(map);

    if (contactDetailsResponseBean.statusCode == 400) {
      setState(() {
        isLoader = true;
        MyPlatformState.isLoader = true;
      });
      MyApp.callLoginAPI(context);
    }

    if (startIndex == 0 && contactDetailsResponseBean.data == null) {
      setState(() {
        isLoader = true;
        isLoading = true;
      });
    }

    if (contactDetailsResponseBean.status) {
      contactListBeanData = contactDetailsResponseBean.data;
      contactName = [
        for (int i = 0; i < contactListBeanData.length; i++)
          {
            'label': contactListBeanData[i].firstname,
            'value': contactListBeanData[i].id.toString(),
          },
      ];

      contactName.insert(0, {
        'label': '',
        'value': '',
      });

      final jsonList = contactName.map((item) => jsonEncode(item)).toList();

      final uniqueJsonList = jsonList.toSet().toList();

      contactName = uniqueJsonList.map((item) => jsonDecode(item)).toList();

      setState(() {
        isLoader = true;
      });
      callMasterAPI();
    }
  }

  Future<void> callMasterAPI() async {
    setState(() {
      isLoader = true;
      isLoading = true;
    });
    String urlController = ServerUrl.crmMasterDetails;
    var objToSend = {
      "\"condition\"": [],
      "\"${UrlParams.AID}\"": "\"${UrlParams.AID_VALUE}\"",
      "\"${UrlParams.AKEY}\"": "\"${UrlParams.AKEY_VALUE}\"",
      "\"${UrlParams.AV}\"": "\"${UrlParams.AV_VALUE}\"",
    };

    String jsonStr = objToSend.toString();

    String res = await APIClient.getInstance().callAPI(
        context, urlController, HTTPMethod.POST,
        isHeader: true, requestBody: jsonStr);
    Map map = jsonDecode(res);
    DetailsBean detailsBean = DetailsBean.fromJson(map);

    if (detailsBean.statusCode == 400) {}
    if (detailsBean.status) {
      status = [
        for (int i = 0; i < detailsBean.data.length; i++)
          if (detailsBean.data[i].page == "Account")
            if (detailsBean.data[i].key == "Status")
              {
                'label': detailsBean.data[i].name,
                'value': detailsBean.data[i].id.toString(),
              },
      ];
      status.insert(0, {
        'label': '',
        'value': '',
      });

      if (widget.type != "Add") {
        form = json.encode({
          'fields': [
            {
              'apiKeyValue': 'companyid',
              'key': 'Status',
              'type': 'select',
              'label': 'Select Company',
              'required': true,
              'readOnly': false,
              'value': widget.dealListBean.companyid.id.toString() ?? "",
              'items': companyName != null
                  ? companyName
                  : [
                      {'label': 'New', 'value': '1'},
                      {'label': 'Active', 'value': '2'},
                      {'label': 'Inactive', 'value': '3'},
                    ]
            },
            {
              'apiKeyValue': 'contactid',
              'key': 'Status',
              'type': 'select',
              'label': 'Select Contact',
              'required': true,
              'readOnly': false,
              'value': widget.dealListBean.contactid.id.toString() ?? "",
              'items': contactName != null
                  ? contactName
                  : [
                      {'label': 'New', 'value': '1'},
                      {'label': 'Active', 'value': '2'},
                      {'label': 'Inactive', 'value': '3'},
                    ]
            },
            {
              'apiKeyValue': 'statusid',
              'key': 'Status',
              'type': 'select',
              'label': 'Status',
              'required': true,
              'readOnly': false,
              'value': widget.dealListBean.statusid.id.toString() ?? "",
              'items': status != null
                  ? status
                  : [
                      {'label': 'New', 'value': '1'},
                      {'label': 'Active', 'value': '2'},
                      {'label': 'Inactive', 'value': '3'},
                    ]
            },
            {
              'apiKeyValue': 'name',
              'key': 'text',
              'type': 'input',
              'label': 'Name',
              'required': true,
              'readOnly': false,
              "value":widget.dealListBean.name?? "",
            },
            {
              'apiKeyValue': 'desc',
              'key': 'text',
              'type': 'input',
              'label': 'Description',
              'required': true,
              'readOnly': false,
              "value": widget.dealListBean.desc ?? "",
            },
            {
              'apiKeyValue': 'probability',
              'key': 'number',
              'type': 'input',
              'label': 'Probability',
              'required': true,
              'readOnly': false,
              "value":widget.dealListBean.probability.toString() ?? "",
            },
            {
              'apiKeyValue': 'dealcost',
              'key': 'number',
              'type': 'input',
              'label': 'Deal Cost',
              'required': true,
              'readOnly': false,
              "value": widget.dealListBean.dealcost.toString() ?? "",
            },
            {
              'apiKeyValue': 'closingdate',
              'key': 'dueDate',
              'type': 'date',
              'label': 'Closing Date',
              'required': true,
              'value': "${MyApp.buiFormatter.buiDateTimeYYYYMMDDFormat(widget.dealListBean.closingdate.toString())}" ?? "",
            },
          ]
        });
      } else {
        form = json.encode({
          'fields': [
            {
              'apiKeyValue': 'companyid',
              'key': 'Status',
              'type': 'select',
              'label': 'Select Company',
              'required': true,
              'readOnly': false,
              'value': '',
              'items': companyName != null
                  ? companyName
                  : [
                      {'label': 'New', 'value': '1'},
                      {'label': 'Active', 'value': '2'},
                      {'label': 'Inactive', 'value': '3'},
                    ]
            },
            {
              'apiKeyValue': 'contactid',
              'key': 'Status',
              'type': 'select',
              'label': 'Select Contact',
              'required': true,
              'readOnly': false,
              'value': '',
              'items': contactName != null
                  ? contactName
                  : [
                      {'label': 'New', 'value': '1'},
                      {'label': 'Active', 'value': '2'},
                      {'label': 'Inactive', 'value': '3'},
                    ]
            },
            {
              'apiKeyValue': 'statusid',
              'key': 'Status',
              'type': 'select',
              'label': 'Status',
              'required': true,
              'readOnly': false,
              'value': '',
              'items': status != null
                  ? status
                  : [
                      {'label': 'New', 'value': '1'},
                      {'label': 'Active', 'value': '2'},
                      {'label': 'Inactive', 'value': '3'},
                    ]
            },
            {
              'apiKeyValue': 'name',
              'key': 'text',
              'type': 'input',
              'label': 'Name',
              'required': true,
              'readOnly': false,
              "value": "",
            },
            {
              'apiKeyValue': 'desc',
              'key': 'text',
              'type': 'input',
              'label': 'Description',
              'required': true,
              'readOnly': false,
              "value": "",
            },
            {
              'apiKeyValue': 'probability',
              'key': 'number',
              'type': 'input',
              'label': 'Probability',
              'required': true,
              'readOnly': false,
              "value": "",
            },
            {
              'apiKeyValue': 'dealcost',
              'key': 'number',
              'type': 'input',
              'label': 'Deal Cost',
              'required': true,
              'readOnly': false,
              "value": "",
            },
            {
              'apiKeyValue': 'closingdate',
              'key': 'dueDate',
              'type': 'date',
              'label': 'Closing Date',
              'required': true,
              'value': widget.dateTime != null
                  ? "${MyApp.buiFormatter.dateToStringDateReverseWithOutTime(DateTime.now())}"
                  : "",
            },
            {
              'apiKeyValue': 'owner_id',
              'key': 'number',
              'type': 'input',
              'label': 'Owner Id',
              'required': true,
              'readOnly': true,
              'visibility': false,
              "value": widget.ownerId ?? "",
            },
          ]
        });
      }

      setState(() {
        isLoader = false;
        isLoading = false;
      });
    } else {
      setState(() {
        isLoader = false;
        isLoading = false;
      });
    }
  }

  Future<void> dealCreateAPI(String jsonString) async {
    String urlController = ServerUrl.crmDealsCreate;
    String res = await APIClient.getInstance().callAPI(
        context, urlController, HTTPMethod.POST,
        isHeader: true, requestBody: jsonString.toString());
    Map map = jsonDecode(res);
    BaseResponse baseBean = BaseResponse.fromJson(map);
    if (baseBean.status) {
      Utils.showInSnackBar(_scaffoldKey, baseBean.message);
      widget.onCallBack();
      Navigator.pop(context);
    } else {
      Utils.showInSnackBar(_scaffoldKey, baseBean.message);
    }
  }
  Future<void> dealUpdateAPI(String jsonString) async {

    String urlController = ServerUrl.crmDealsUpdate;
    var objToSend = {
      "\"condition\"": [
        {"\"id\"": widget.id.toString()}
      ],
      "\"data\"": [jsonString.toString()],
      "\"${UrlParams.AID}\"": "\"${UrlParams.AID_VALUE}\"",
      "\"${UrlParams.AKEY}\"": "\"${UrlParams.AKEY_VALUE}\"",
      "\"${UrlParams.AV}\"": "\"${UrlParams.AV_VALUE}\"",
    };

    String jsonStr = objToSend.toString();

    String res = await APIClient.getInstance().callAPI(
        context, urlController, HTTPMethod.POST,
        isHeader: true, requestBody: jsonStr);
    Map map = jsonDecode(res);
    BaseResponse baseBean = BaseResponse.fromJson(map);
    if (baseBean.status) {
      Utils.showInSnackBar(_scaffoldKey, baseBean.message);
      widget.onCallBack();
      Navigator.pop(context);
    } else {
      Utils.showInSnackBar(_scaffoldKey, baseBean.message);
    }

  }
}
