import 'package:bui_component/Constants/AppColors.dart';
import 'package:bui_component/DrawerComonent/kfDrawer.dart';
import 'package:bui_component/ThemeComponent/ThemeColorComponent.dart';
import 'package:example/Constants/AppStrings.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:shared_preferences/shared_preferences.dart';

class ThemePickerScreen extends KFDrawerContent {
  Function() onBackPressed;

  ThemePickerScreen({this.onBackPressed});

  @override
  ThemePickerScreenState createState() => ThemePickerScreenState();
}

class ThemePickerScreenState extends State<ThemePickerScreen> {
  static bool isSelected = false;

  static Color primaryColor = AppColors.primaryColor;
  static Color secondaryColor = AppColors.primaryColor;

  @override
  void initState() {
    super.initState();
    colorCodePref();
    setState(() {
      isSelected = true;
    });
  }

  Color appbarColor = Colors.blueGrey;

  Color backgroundColor = AppColors.APP_COLOR_PRIMARY;
  Color secondaryColorTheme = AppColors.APP_COLOR_PRIMARY;

  Set<Color> swatches = Colors.primaries.map((e) => Color(e.value)).toSet();

  colorCodePref() async {
    SharedPreferences prefs = await SharedPreferences.getInstance();

    String stringValue = prefs.getString(AppStrings.PRIMARY_THEME_COLOR);
    String secondaryColorPref =
        prefs.getString(AppStrings.SECONDARY_THEME_COLOR);

    if (stringValue != null) {
      int colorCodeInt = int.parse(stringValue);

      setState(() {
        backgroundColor = Color(colorCodeInt);

        primaryColor = Color(colorCodeInt);
        this.mounted;
      });
    } else {
      backgroundColor = AppColors.APP_COLOR_PRIMARY;
      primaryColor = AppColors.APP_COLOR_PRIMARY;
    }

    if (secondaryColorPref != null) {
      int colorCodeInt = int.parse(secondaryColorPref);
      setState(() {
        secondaryColorTheme = Color(colorCodeInt);
        secondaryColor = Color(colorCodeInt);
        this.mounted;
      });
    } else {
      setState(() {
        secondaryColorTheme = AppColors.APP_COLOR_PRIMARY;
        secondaryColor = AppColors.APP_COLOR_PRIMARY;
        this.mounted;
      });
    }
  }

  @override
  Widget build(BuildContext context) {
    SystemChrome.setSystemUIOverlayStyle(SystemUiOverlayStyle(
      statusBarColor: backgroundColor ?? AppColors.APP_COLOR_PRIMARY,
      //top bar color
      statusBarIconBrightness: Brightness.light,
      //top bar icons
      systemNavigationBarColor: Colors.black,
      //bottom bar color
      systemNavigationBarIconBrightness: Brightness.dark, //bottom bar icons
    ));
    return SafeArea(
      child: WillPopScope(
        onWillPop: () {
          onBackPressed();
        },
        child: ThemeColorComponent(
          onMenuPressed: onMenuPressed,
          onBackPressed: onBackPressed,
          backgroundColor: backgroundColor,
          secondaryColor: secondaryColorTheme,
        ),
      ),
    );
  }

  Future<void> onBackPressed() async {
    widget.onBackPressed();
    Navigator.pop(context);
  }

  Future<void> onMenuPressed() async {
    setState(() {
      isSelected = true;
      colorCodePref();
      widget.onMenuPressed();
    });
  }
}
