import 'package:bui_component/Constants/fontSize.dart';
import 'package:example/Constants/AppColors.dart';
import 'package:example/Constants/AppStrings.dart';
import 'package:example/Constants/SvgPictures.dart';
import 'package:flutter/material.dart';
import 'package:flutter_svg/svg.dart';

class NoDataFoundScreen extends StatefulWidget {
  String svgImage;
  String description;

  NoDataFoundScreen({Key key, this.svgImage, this.description})
      : super(key: key);

  @override
  _NoDataFoundScreenState createState() => _NoDataFoundScreenState();
}

class _NoDataFoundScreenState extends State<NoDataFoundScreen> {
  @override
  Widget build(BuildContext context) {
    return SafeArea(
      child: Container(
          margin: EdgeInsets.only(top: 90),
          child: Center(
            child: Column(
              mainAxisAlignment: MainAxisAlignment.center,
              children: [
                SvgPicture.asset(
                  widget.svgImage ?? SvgPictures.NO_DATA_FOUND,
                  placeholderBuilder: (context) => CircularProgressIndicator(),
                  height: 128.0,
                  allowDrawingOutsideViewBox: false,
                ),
                SizedBox(
                  height: 20,
                ),
                Text(
                  widget.description ?? AppStrings.NO_DATA_FOUND,
                  style: TextStyle(
                      fontWeight: FontWeight.bold,
                      fontSize: FontSize.FONT_20,
                      color: AppColors.APP_GRAY_1),
                ),
              ],
            ),
          )),
    );
  }
}
