import 'dart:convert';

import 'package:bui_component/BuiDrawerComponent/buiDrawer.dart';
import 'package:bui_component/ButtonsComponent/buttonComponent.dart';
import 'package:bui_component/ConditionalDropDown/awesome_dropdown.dart';
import 'package:bui_component/Constants/fontSize.dart';
import 'package:bui_component/ShimmerComponent/flutter_shimmer_loading_widget.dart';
import 'package:example/Constants/AppColors.dart';
import 'package:example/Constants/AppStrings.dart';
import 'package:example/Constants/fontFamily.dart';
import 'package:example/Constants/server_url.dart';
import 'package:example/Models/base_bean.dart';
import 'package:example/Models/details_bean.dart';
import 'package:example/Screens/CRM/DrawerMenuHeaderDesign.dart';
import 'package:example/Utils/Utility.dart';
import 'package:example/network/api_service.dart';
import 'package:flutter/material.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:toast/toast.dart';
import 'package:transition/transition.dart';

import '../CommonViewDetailScreen.dart';

class PMOSettingScreen extends DrawerContent {
  int permissionStr;

  PMOSettingScreen({Key key, this.permissionStr});

  @override
  _PMOSettingScreenState createState() => _PMOSettingScreenState();
}

class _PMOSettingScreenState extends State<PMOSettingScreen> {
  bool isLoader = false;

  String jsonForm;

  dynamic response;

  dynamic formGeneral;

  final GlobalKey<ScaffoldState> _scaffoldKey = new GlobalKey<ScaffoldState>();

  Map keyBoardTypes = {
    'number': TextInputType.number,
    'text': TextInputType.text,
    'email': TextInputType.emailAddress,
    'password': TextInputType.visiblePassword,
  };
  Map errorValidation = {
    'text': "Required this field.",
  };

  Color primaryColor = AppColors.APP_COLOR_PRIMARY;

  Color secondaryColor;

  SharedPreferences prefs;

  String ownerId;

  List<String> pages = new List.empty(growable: true);

  String _pagesName = '';

  bool _isBackPressedOrTouchedOutSide = false,
      _isDropDownOpened = false,
      _isPanDown = false;

  List<MasterDataList> detailsListBean = new List.empty(growable: true);
  DetailsBean detailsBeanResponse;

  List<String> keys = new List.empty(growable: true);

  bool isVisible = false;

  List<String> status = new List.empty(growable: true);
  String _keyName;
  String _statusName;

  final descController = TextEditingController();

  final nameController = TextEditingController();

  var _formKey = GlobalKey<FormState>();

  bool visible = true;

  @override
  void initState() {
    // TODO: implement initState
    super.initState();

    _pagesName = 'Select Item';
    _keyName = 'Select Item';
    _statusName = 'Select Item';

    colorCodePref();

    callMasterViewAPI();
    permissionMethod();
  }

  @override
  Widget build(BuildContext context) {
    return SafeArea(
      child: Scaffold(
        key: _scaffoldKey,
        body: Center(
          child: ListView(
            children: [
              DrawerMenuDesign(
                onMenuClicked: widget.onMenuPressed,
                isFilterEnabled: false,
              ),
              Stack(children: [isLoader ? _isLoaderView : _mainView]),
              // isLoader ? _isLoaderView : _mainView
            ],
          ),
        ),
        floatingActionButton: Visibility(
          visible: visible,
          child: FloatingActionButton(
            mini: true,
            onPressed: () {
              Navigator.push(
                  context,
                  Transition(
                      child: CommonViewDetailScreen(
                        primaryColor: primaryColor,
                        secondaryColor: secondaryColor,
                        pageId: AppStrings.pmoOwnerPermission,
                        ownerId: ownerId ?? "7",
                        title:
                            AppStrings.create + AppStrings.pmoOwnerPermission,
                        commonDD: [1, 2, 3],
                        onCallBack: () {
                          callMasterViewAPI();
                        },
                        permissionStr: widget.permissionStr,
                      ),
                      transitionEffect: TransitionEffect.RIGHT_TO_LEFT));
            },
            child: const Icon(Icons.add),
            backgroundColor: primaryColor,
          ),
        ),
      ),
    );
  }

  Widget get _mainView {
    /* return JsonSchema(
      keyboardTypes: keyBoardTypes,
      errorMessages: errorValidation,
      primaryColor: primaryColor ?? AppColors.primaryColor,
      secondaryColor: secondaryColor ?? AppColors.APP_COLOR_PRIMARY,
      form: jsonForm,
      onChanged: (dynamic response) {
        this.response = response;
      },
      buttonText: AppStrings.ADD,
      actionSave: (data) {
        setState(() {
          formGeneral = data;
        });

        var jsonObj = {
          for (int i = 0; i < data['fields'].length; i++)
            json.encode(data['fields'][i]['apiKeyValue'].toString()):
                json.encode(data['fields'][i]['value'].toString()),
          "\"${UrlParams.AID}\"": "\"${UrlParams.AID_VALUE}\"",
          "\"${UrlParams.AKEY}\"": "\"${UrlParams.AKEY_VALUE}\"",
          "\"${UrlParams.AV}\"": "\"${UrlParams.AV_VALUE}\"",
        };

        Logger.logMessage(Log.DEBUG, jsonObj.toString());

        //callMasterPageCreateAPI(jsonObj.toString());
      },
      actionCancel: () {
        Navigator.pop(context);
      },
      buttonSave: true,
    );*/
    return Form(
      key: _formKey,
      child: Column(
        children: [
          _buildTextView("Pages"),
          Container(
            width: MediaQuery.of(context).size.width,
            margin: EdgeInsets.only(top: 5, bottom: 2, left: 16, right: 20),
            child: AwesomeDropDown(
              dropDownList: pages,
              selectedItem: _pagesName,
              onDropDownItemClick: (selectedItem) {
                _pagesName = selectedItem;
                //
                keys = [
                  for (int i = 0; i < detailsListBean.length; i++)
                    if (detailsListBean[i].page.toString() == selectedItem)
                      detailsListBean[i].key,
                ];
                keys = keys.toSet().toList();
                print("Pages====" + keys.toString());

                setState(() {
                  isVisible = true;
                });
              },
              dropStateChanged: (isOpened) {
                _isDropDownOpened = isOpened;
                if (!isOpened) {
                  _isBackPressedOrTouchedOutSide = false;
                }
              },
            ),
          ),
          Visibility(visible: isVisible, child: _buildTextView("Key")),
          Visibility(
            visible: isVisible,
            child: Container(
              width: MediaQuery.of(context).size.width,
              margin: EdgeInsets.only(top: 5, bottom: 2, left: 16, right: 20),
              child: AwesomeDropDown(
                dropDownList: keys,
                selectedItem: _keyName,
                onDropDownItemClick: (selectedItem) {
                  _keyName = selectedItem;
                  status = [
                    for (int i = 0; i < detailsListBean.length; i++)
                      detailsListBean[i].status,
                  ];
                  //status = status.toSet().toList();
                  print("Pages====" + status.toString());
                },
                dropStateChanged: (isOpened) {
                  _isDropDownOpened = isOpened;
                  if (!isOpened) {
                    _isBackPressedOrTouchedOutSide = false;
                  }
                },
              ),
            ),
          ),
          _buildTextView("Name"),
          Container(
            padding: const EdgeInsets.all(8),
            margin: EdgeInsets.only(top: 5, bottom: 2, left: 8, right: 8),
            child: TextFormField(
              controller: nameController,
              decoration: new InputDecoration(
                filled: true,
                fillColor: Colors.white,
                hintText: "Name",
                enabledBorder: OutlineInputBorder(
                  borderRadius: BorderRadius.circular(5.0),
                  borderSide: BorderSide(
                    color: primaryColor,
                    width: 1.0,
                  ),
                ),
                focusedBorder: OutlineInputBorder(
                  borderRadius: BorderRadius.circular(5.0),
                  borderSide: BorderSide(
                    color: primaryColor,
                  ),
                ),
                contentPadding: const EdgeInsets.all(5.0),
                border: OutlineInputBorder(
                  borderRadius: BorderRadius.circular(5.0),
                ),
              ),
              validator: (value) {
                if (value.length == 0) {
                  return "Please Enter Some Text";
                }
                return null;
              },
              onChanged: (String value) {},
              onFieldSubmitted: (value) {
                Utils.hideKeyboard(context);
              },
            ),
          ),
          _buildTextView("Description"),
          Container(
            padding: const EdgeInsets.all(8),
            margin: EdgeInsets.only(top: 5, bottom: 2, left: 8, right: 8),
            child: TextFormField(
              controller: descController,
              decoration: new InputDecoration(
                filled: true,
                fillColor: Colors.white,
                hintText: "Description",
                enabledBorder: OutlineInputBorder(
                  borderRadius: BorderRadius.circular(5.0),
                  borderSide: BorderSide(
                    color: primaryColor,
                    width: 1.0,
                  ),
                ),
                focusedBorder: OutlineInputBorder(
                  borderRadius: BorderRadius.circular(5.0),
                  borderSide: BorderSide(
                    color: primaryColor,
                  ),
                ),
                contentPadding: const EdgeInsets.all(5.0),
                border: OutlineInputBorder(
                  borderRadius: BorderRadius.circular(5.0),
                ),
              ),
              validator: (value) {
                if (value.length == 0) {
                  return "Please Enter Some Text";
                }
                return null;
              },
              onChanged: (String value) {},
              onFieldSubmitted: (value) {
                Utils.hideKeyboard(context);
              },
            ),
          ),
          Container(
              margin: EdgeInsets.only(top: 5, bottom: 2, left: 16, right: 20),
              child: Row(
                mainAxisAlignment: MainAxisAlignment.spaceAround,
                children: [
                  Button.mini(
                    width: MediaQuery.of(context).size.width * 0.3,
                    onPressed: () {
                      Navigator.of(context).pop();
                    },
                    buttonSize: ButtonSize.medium,
                    buttonType: ButtonType.custom,
                    btnColor: AppColors.APP_BUTTON_GREY,
                    btnTextColor: primaryColor,
                    btnText: AppStrings.CANCEL,
                    elevation: 10,
                  ),
                  Button.mini(
                    width: MediaQuery.of(context).size.width * 0.3,
                    onPressed: () {
                      final isValid = _formKey.currentState.validate();
                      if (!isValid) {
                        return;
                      } else {
                        if (keys.isNotEmpty &&
                            _keyName.isNotEmpty &&
                            _statusName.isNotEmpty &&
                            descController.text.isNotEmpty &&
                            nameController.text.isNotEmpty) {
                          print("Added====" +
                              _pagesName +
                              "&" +
                              _keyName +
                              "&" +
                              descController.text +
                              "&" +
                              nameController.text);

                          var obj = {
                            "\"page\"": "\"${_pagesName.toString()}\"",
                            "\"key\"": "\"${_keyName.toString()}\"",
                            "\"name\"": "\"${nameController.text}\"",
                            "\"desc\"": "\"${descController.text}\"",
                            "\"${UrlParams.AID}\"":
                                "\"${UrlParams.AID_VALUE}\"",
                            "\"${UrlParams.AKEY}\"":
                                "\"${UrlParams.AKEY_VALUE}\"",
                            "\"${UrlParams.AV}\"": "\"${UrlParams.AV_VALUE}\"",
                          };

                          //print("Json Obj ====" + obj.toString());
                          callMasterPageCreateAPI(obj.toString());
                        } else {
                          Toast.show("Required All Fields", context);
                        }
                      }
                      _formKey.currentState.save();
                    },
                    buttonSize: ButtonSize.medium,
                    buttonType: ButtonType.custom,
                    btnColor: secondaryColor ?? AppColors.APP_COLOR_PRIMARY,
                    btnTextColor: Colors.white,
                    btnText: AppStrings.SAVE,
                    elevation: 10,
                  ),
                ],
              )),
        ],
      ),
    );
  }

  Widget get _isLoaderView {
    /*return Center(
      child: Loader(
        loaderColor: primaryColor,
      ),
    );*/

    return Container(
        height: MediaQuery.of(context).size.height * 0.80,
        margin: EdgeInsets.only(top: 30),
        child: ListView.builder(
          itemCount: 100,
          itemBuilder: (context, index) {
            return Column(
              children: [
                Padding(
                  padding: const EdgeInsets.all(8.0),
                  child: FlutterShimmnerLoadingWidget(
                    count: 2,
                    animate: true,
                    color: Colors.grey[200],
                  ),
                ),
              ],
            );
          },
        ));
  }

  Widget _buildTextView(String label) {
    return Container(
        width: MediaQuery.of(context).size.width,
        margin: EdgeInsets.only(top: 5, left: 16, right: 20),
        child: RichText(
          text: TextSpan(
            text: label,
            style: TextStyle(
                fontSize: FontSize.FONT_18,
                fontFamily: FontFamily.Gilroy,
                fontWeight: FontWeight.bold,
                color: primaryColor ?? AppColors.primaryColor),
            children: const <TextSpan>[
              TextSpan(
                  text: ' *',
                  style: TextStyle(
                      fontWeight: FontWeight.bold,
                      color: AppColors.errorWarning)),
            ],
          ),
        )

        /*Text(
        label,
        style: TextStyle(
            fontSize: FontSize.FONT_18,
            fontFamily: FontFamily.Gilroy,
            fontWeight: FontWeight.bold,
            color: widget.primaryColor ?? AppColors.primaryColor),
      ),*/
        );
  }

  colorCodePref() async {
    prefs = await SharedPreferences.getInstance();
    String stringValue = prefs.getString(AppStrings.PRIMARY_THEME_COLOR);

    String ownerIdValue = prefs.getString(AppStrings.OWNER_ID);
    setState(() {
      ownerId = ownerIdValue;
    });

    String secondaryColorPref =
        prefs.getString(AppStrings.SECONDARY_THEME_COLOR);

    if (stringValue != null) {
      int colorCodeInt = int.parse(stringValue);

      setState(() {
        primaryColor = Color(colorCodeInt);
        this.mounted;
      });
    }

    if (secondaryColorPref != null) {
      int colorCodeInt = int.parse(secondaryColorPref);
      setState(() {
        secondaryColor = Color(colorCodeInt);
        this.mounted;
      });

      return secondaryColorPref;
    } else {
      secondaryColor = AppColors.APP_COLOR_PRIMARY;
    }
  }

  Future<void> callMasterPageCreateAPI(String obj) async {
    setState(() {
      isLoader = true;
    });

    String urlController = ServerUrl.pmoMasterCreate;

    String jsonStr = obj.toString();

    String res = await APIClient.getInstance().callAPI(
        context, urlController, HTTPMethod.POST,
        isHeader: true, requestBody: jsonStr);
    Map map = jsonDecode(res);

    BaseResponse baseResponseBean = BaseResponse.fromJson(map);
    if (baseResponseBean.status) {
      setState(() {
        isLoader = false;
      });
      Utils.showInSnackBar(_scaffoldKey, baseResponseBean.message.toString());
    } else {
      setState(() {
        isLoader = false;
      });
      Utils.showInSnackBar(_scaffoldKey, baseResponseBean.message.toString());
    }
  }

  Future<void> callMasterViewAPI() async {
    setState(() {
      isLoader = true;
    });
    String urlController = ServerUrl.pmoMaster;
    var objToSend = {
      "\"condition\"": [],
      "\"${UrlParams.AID}\"": "\"${UrlParams.AID_VALUE}\"",
      "\"${UrlParams.AKEY}\"": "\"${UrlParams.AKEY_VALUE}\"",
      "\"${UrlParams.AV}\"": "\"${UrlParams.AV_VALUE}\"",
    };

    String jsonStr = objToSend.toString();

    String res = await APIClient.getInstance().callAPI(
        context, urlController, HTTPMethod.POST,
        isHeader: true, requestBody: jsonStr);
    Map map = jsonDecode(res);
    DetailsBean detailsBean = DetailsBean.fromJson(map);

    if (detailsBean.statusCode == 400) {}
    if (detailsBean.status) {
      detailsBeanResponse = detailsBean;
      detailsListBean = detailsBean.data;
      pages = [
        for (int i = 0; i < detailsBean.data.length; i++)
          if (detailsBean.data[i].page.toString() != null)
            detailsBean.data[i].page,
      ];

      pages = pages.toSet().toList();

      print("Status====" + pages.toString());

      setState(() {
        isLoader = false;
      });
    } else {
      setState(() {
        isLoader = false;
      });
    }
  }

  void permissionMethod() {
    if (widget.permissionStr == AppStrings.fullAccessForAll) {
      setState(() {
        visible = true;
      });
    } else if (widget.permissionStr == AppStrings.viewAccessForOwn) {
      setState(() {
        visible = false;
      });
    } else if (widget.permissionStr == AppStrings.viewAndAddAccessForOwn) {
      setState(() {
        visible = true;
      });
    } else if (widget.permissionStr == AppStrings.fullAccessForOwn) {
      setState(() {
        visible = true;
      });
    } else if (widget.permissionStr == AppStrings.viewAccessForAllUser) {
      setState(() {
        visible = false;
      });
    } else if (widget.permissionStr == AppStrings.viewAndAddAccessForAllUser) {
      setState(() {
        visible = true;
      });
    } else if (widget.permissionStr == AppStrings.noAccessPermission) {
      setState(() {
        visible = false;
      });
    } else {
      setState(() {
        visible = false;
      });
    }
  }
}
