import 'dart:convert';

import 'package:bui_component/Constants/AppColors.dart';
import 'package:bui_component/Constants/AppStrings.dart';
import 'package:bui_component/JsonFormComponent/json_schema.dart';
import 'package:example/main.dart';
import 'package:flutter/material.dart';

class TestScreen extends StatefulWidget {
  const TestScreen({Key key}) : super(key: key);

  @override
  _TestScreenState createState() => _TestScreenState();
}

class _TestScreenState extends State<TestScreen> {
  String jsonForm = json.encode({
    'fields': [
      {
        'apiKeyValue': 'date',
        'key': 'dueDate',
        'type': 'date',
        'label': 'Date',
        'required': true,
        'value':
            MyApp.buiFormatter.dateToStringDateReverseWithOutTime(DateTime.now()) ?? "",
      },
    ]
  });

  dynamic response;

  dynamic formGeneral;

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: JsonSchema(
        primaryColor: AppColors.primaryColor,
        secondaryColor: AppColors.APP_COLOR_PRIMARY,
        form: jsonForm,
        onChanged: (dynamic response) {
          this.response = response;
        },
        buttonText: AppStrings.save,
        actionSave: (data) {
          setState(() {
            formGeneral = data;
          });
        },
        actionCancel: () {
          Navigator.pop(context);
        },
        buttonSave: true,
      ),
    );
  }
}
