import 'package:bui_component/CardComponent/cardComponent.dart';
import 'package:bui_component/Constants/AppColors.dart';
import 'package:bui_component/Constants/SvgPictures.dart';
import 'package:bui_component/Constants/fontFamily.dart';
import 'package:bui_component/Constants/fontSize.dart';
import 'package:flutter/material.dart';
import 'package:flutter_svg/svg.dart';

class BUICard extends StatelessWidget {
  CardType cardType;

  double elevation;

  CardSize cardSize;

  Color cardColor;

  double width;

  double height;

  double padding;

  Widget image;

  double fontSize;

  double imageSize;

  //not required, button shape.
  ShapeBorder shape;

  String cardText;
  String cardTitle;
  String cardName;
  String statusTag;
  String dashBoardCardTime;
  String lastMonthPrice;
  String currentMonthPrice;

  String cardPrice;
  String cardPercentage;
  String cardDate;
  bool trendValue;

  bool isTagValue;
  List<String> tagValue = [];

  //TaskCard String Values

  String cardStatus;
  String cardDesc;
  String cardAuthor;

  Color secondaryColor;

  //not required, Gets value according to buttonType.

  Color cardTextColor;

  bool mini;

  bool titleCard;

  bool dashBoardCard;

  bool dashBoardCardDeals;

  bool taskCard;

  bool notesCard;

  Function() onStateChange;

  bool isActiveStatus = false;

  String firstHalf;
  String secondHalf;

  bool flag;

  bool isModuleCard;

  double borderRadius;

  String sourceImage;

  bool isVisible;

  bool isEnabled;

  List<Color> gradientColor;

  double radius;

  bool isGrid;

  TextStyle textStyle;

  BUICard({
    this.cardType,
    this.elevation,
    this.cardSize,
    this.cardColor,
    this.width,
    this.height,
    this.padding,
    this.shape,
    this.cardText,
    this.cardTextColor,
    this.textStyle,
  })  : mini = false,
        dashBoardCardDeals = false,
        titleCard = false,
        dashBoardCard = false;

  BUICard.mini({
    this.cardType,
    this.elevation,
    this.cardSize,
    this.cardColor,
    this.textStyle,
  })  : mini = true,
        titleCard = false;

  BUICard.titleCard({
    this.cardTitle,
    this.cardName,
    this.cardType,
    this.elevation,
    this.cardSize,
    this.cardColor,
    this.width,
    this.height,
    this.padding,
    this.shape,
    this.cardText,
    this.cardTextColor,
    this.textStyle,
  })  : titleCard = true,
        mini = false;

  BUICard.dashBoardCard({
    this.cardTitle,
    this.statusTag,
    this.cardName,
    this.cardType,
    this.dashBoardCardTime,
    this.elevation,
    this.cardSize,
    this.cardColor,
    this.width,
    this.height,
    this.padding,
    this.shape,
    this.cardTextColor,
    this.tagValue,
    this.isTagValue,
    this.textStyle,
  })  : titleCard = false,
        dashBoardCard = true,
        mini = false;

  BUICard.dashBoardCardDeals({
    this.padding,
    this.cardSize,
    this.height,
    this.width,
    this.cardTitle,
    this.cardType,
    this.currentMonthPrice,
    this.lastMonthPrice,
    this.cardDate,
    this.elevation,
    this.trendValue,
    this.cardTextColor,
    this.cardColor,
    this.shape,
    this.textStyle,
  })  : dashBoardCardDeals = true,
        titleCard = false,
        dashBoardCard = false,
        mini = false;

  BUICard.taskCard({
    this.cardStatus,
    this.cardDesc,
    this.cardDate,
    this.cardType,
    this.cardSize,
    this.cardColor,
    this.cardTextColor,
    this.shape,
    this.elevation,
    this.width,
    this.height,
    this.padding,
    this.onStateChange,
    this.isActiveStatus,
    this.secondaryColor,
    this.textStyle,
  })  : taskCard = true,
        dashBoardCardDeals = false,
        titleCard = false,
        dashBoardCard = false,
        mini = false;

  BUICard.notesCard({
    this.cardAuthor,
    this.cardDesc,
    this.cardDate,
    this.cardType,
    this.cardSize,
    this.cardColor,
    this.cardTextColor,
    this.shape,
    this.elevation,
    this.width,
    this.height,
    this.padding,
    this.secondaryColor,
    this.onStateChange,
    this.flag,
    this.textStyle,
  })  : notesCard = true,
        taskCard = false,
        dashBoardCardDeals = false,
        titleCard = false,
        dashBoardCard = false,
        mini = false;

  BUICard.imageWithTextCard({
    this.cardText,
    this.cardType,
    this.cardSize,
    this.cardTextColor,
    this.width,
    this.height,
    this.borderRadius,
    this.sourceImage,
    this.isVisible,
    this.isEnabled,
    this.radius,
    this.cardColor,
    this.isGrid,
    this.padding,
    this.shape,
    this.textStyle,
  })  : isModuleCard = true,
        notesCard = false,
        taskCard = false,
        dashBoardCardDeals = false,
        titleCard = false,
        dashBoardCard = false,
        mini = false;

  @override
  Widget build(BuildContext context) {
    _setCardSize();
    _createStyle(context);
    final textTheme = Theme.of(context).textTheme;
    if (mini) {
      return Container(
        child: Card(
          shape: shape,
          color: cardColor,
          child: Text(
            cardText,
            style: TextStyle(letterSpacing: 1, color: cardTextColor),
          ),
          elevation: elevation,
        ),
      );
    } else if (titleCard) {
      return Container(
        width: width,
        height: height,
        child: Card(
          shape: shape,
          color: cardColor,
          elevation: elevation,
          child: Column(
            crossAxisAlignment: CrossAxisAlignment.start,
            children: [
              Container(
                padding: EdgeInsets.all(padding),
                child: Text(
                  cardTitle,
                  style: TextStyle(
                      letterSpacing: 1,
                      color: cardTextColor,
                      fontSize: FontSize.FONT_19,
                      fontWeight: FontWeight.bold,
                      fontFamily: FontFamily.Gilroy),
                ),
              ),
              Container(
                padding: EdgeInsets.all(padding),
                child: Text(
                  cardName,
                  style: TextStyle(
                      letterSpacing: 1,
                      color: cardTextColor,
                      fontSize: FontSize.FONT_15,
                      fontWeight: FontWeight.w300,
                      fontFamily: FontFamily.Gilroy),
                ),
              ),
              Container(
                padding: EdgeInsets.all(padding),
                child: Text(
                  cardText,
                  style: TextStyle(
                      letterSpacing: 1,
                      color: cardTextColor,
                      fontSize: FontSize.FONT_13,
                      fontWeight: FontWeight.w300,
                      fontFamily: FontFamily.Gilroy),
                ),
              ),
            ],
          ),
        ),
      );
    } else if (dashBoardCard) {
      return Container(
        padding: EdgeInsets.all(padding),
        width: width,
        height: height,
        child: Card(
          shape: shape,
          color: cardColor,
          elevation: elevation,
          child: Column(
            crossAxisAlignment: CrossAxisAlignment.start,
            children: [
              Row(
                mainAxisAlignment: MainAxisAlignment.spaceBetween,
                children: [
                  Container(
                    width: 200,
                    padding: EdgeInsets.only(left: 10, top: 10),
                    child: Text(
                      cardTitle,
                      softWrap: false,
                      style:
                          textTheme.bodyText1.copyWith(
                            fontSize: 16,
                            fontWeight: FontWeight.bold,
                            wordSpacing: 1,
                            letterSpacing: 1,
                          ),
                    ),
                  ),
                  Visibility(
                    visible: isTagValue,
                    child: Container(
                      padding: EdgeInsets.only(left: 5, right: 5),
                      alignment: Alignment.center,
                      height: 20,
                      width: 70,
                      margin: EdgeInsets.only(right: 10, top: 10),
                      decoration: BoxDecoration(
                        color: AppColors.LIGHT_GREY,
                        borderRadius: BorderRadius.circular(5),
                      ),
                      child: Text(
                        statusTag,
                        textAlign: TextAlign.center,
                        softWrap: false,
                        style:
                            textTheme.bodyText1.copyWith(
                              fontSize: 10,
                              fontWeight: FontWeight.bold,
                              wordSpacing: 1,
                              letterSpacing: 1,
                            ),
                      ),
                    ),
                  ),
                ],
              ),
              Container(
                padding: EdgeInsets.only(left: 5, top: 5),
                margin: EdgeInsets.only(left: 5, top: 5),
                child: Text(
                  cardName,
                  style:
                      textTheme.bodyText1.copyWith(
                        fontSize: 14,
                        fontWeight: FontWeight.normal,
                        wordSpacing: 1,
                        letterSpacing: 1,
                      ),
                ),
              ),
              if (isTagValue)
                if (tagValue.isNotEmpty)
                  Container(
                    height: 30,
                    padding: EdgeInsets.only(left: 1, right: 5),
                    margin: EdgeInsets.only(left: 10, top: 1),
                    child: ListView.builder(
                        shrinkWrap: true,
                        scrollDirection: Axis.horizontal,
                        itemCount: tagValue.length,
                        itemBuilder: (BuildContext context, int index) {
                          return Container(
                            /*padding: EdgeInsets.only(left: 3, right: 5),*/
                            margin: EdgeInsets.only(right: 10, top: 10),
                            child: Container(
                              alignment: Alignment.center,
                              height: 15,
                              width: 100,
                              decoration: BoxDecoration(
                                color: AppColors.LIGHT_GREY,
                                borderRadius: BorderRadius.circular(4),
                              ),
                              child: Text(
                                //"#"+index.toString(),
                                tagValue[index],
                                softWrap: true,
                                maxLines: 1,
                                style:
                                    textTheme.bodyText1.copyWith(
                                      fontSize: 10,
                                      fontWeight: FontWeight.normal,
                                      wordSpacing: 1,
                                      letterSpacing: 1,
                                    ),
                              ),
                            ),
                          );
                        }),
                  ),
              if (dashBoardCardTime.isNotEmpty)
                Container(
                  // padding: EdgeInsets.only(left: 5, right: 10),
                  margin: EdgeInsets.only(left: 10, top: 10),
                  alignment: Alignment.centerRight,
                  child: Row(
                    mainAxisAlignment: MainAxisAlignment.end,
                    children: [
                      Container(
                        //padding: EdgeInsets.all(10),
//                      margin: EdgeInsets.only(left: 15),
                        child: Icon(
                          Icons.calendar_today_rounded,
                          size: 20,
                          color: AppColors.APP_COLOR_PRIMARY,
                        ),
                      ),
                      Container(
                        margin: EdgeInsets.only(left: 10, top: 1, right: 5),
                        padding: EdgeInsets.only(top: 1, right: 10),
                        //padding: EdgeInsets.all(5),
                        child: Text(
                          dashBoardCardTime,
                          softWrap: true,
                          maxLines: 1,
                          style:
                              textTheme.bodyText1.copyWith(
                                fontSize: 12,
                                fontWeight: FontWeight.normal,
                                wordSpacing: 1,
                                letterSpacing: 1,
                              ),
                        ),
                      ),
                    ],
                  ),
                ),
            ],
          ),
        ),
      );
    }
    else if (dashBoardCardDeals) {
      return Container(
        margin: EdgeInsets.all(2),
        height: height,
        width: width,
        //padding: EdgeInsets.all(padding),
        child: Card(
          elevation: elevation,
          shape: shape,
          color: cardColor,
          child: Column(
            //shrinkWrap: false,
            crossAxisAlignment: CrossAxisAlignment.start,
            children: [
              Container(
                padding: EdgeInsets.only(left: 10, top: 5, bottom: 0),
                child: Text(
                  cardTitle,
                  style:  textTheme.bodyText1.copyWith(
                    fontSize: 14,
                    fontWeight: FontWeight.bold,

                  ),
                ),
              ),
              Column(
                mainAxisAlignment: MainAxisAlignment.end,
                crossAxisAlignment: CrossAxisAlignment.end,
                children: [
                  Row(
                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                    children: [
                      Container(
                        padding: EdgeInsets.only(left: 10, top: 5),
                        child: Text(
                          lastMonthPrice,
                          style:  textTheme.bodyText1.copyWith(
                            color: cardTextColor,
                            fontSize: 16,
                            fontWeight: FontWeight.bold,
                            wordSpacing: 1,
                            letterSpacing: 1,
                          ),
                        ),
                      ),
                      Container(
                        padding: EdgeInsets.only(right: 10, top: 5),
                        child: Row(
                          children: [
                            Icon(
                              trendValue
                                  ? Icons.arrow_upward_sharp
                                  : Icons.arrow_downward_sharp,
                              color: trendValue
                                  ? Colors.greenAccent
                                  : Colors.redAccent,
                            ),
                            Container(
                              child: Text(
                                currentMonthPrice,

                                style:  textTheme.bodyText1.copyWith(
                                  color: trendValue
                                      ? Colors.greenAccent
                                      : Colors.redAccent,
                                  fontSize: 16,
                                  fontWeight: FontWeight.bold,
                                  wordSpacing: 1,
                                  letterSpacing: 1,
                                ),
                              ),
                            ),
                          ],
                        ),
                      )
                    ],
                  ),
                  Container(
                    //remove padding top to show gridview
                    //padding: EdgeInsets.only(right: 10, bottom: 50, top: 10),
                    padding: EdgeInsets.only(right: 10),
                    //margin: EdgeInsets.only(bottom: 50),
                    child: Text(
                      cardDate,
                      style:  textTheme.bodyText1.copyWith(
                        color: trendValue
                            ? Colors.greenAccent
                            : Colors.redAccent,
                        fontSize: 10,
                        fontWeight: FontWeight.bold,
                        wordSpacing: 1,
                        letterSpacing: 1,
                      ),


                    ),
                  ),
                ],
              ),
            ],
          ),
        ),
      );
    }
    else if (taskCard) {
      return Container(
          margin: EdgeInsets.all(2),
          height: height,
          width: width,
          padding: EdgeInsets.all(padding),
          child: Card(
            shape: shape,
            elevation: elevation,
            color: cardColor,
            child: Column(
              mainAxisAlignment: MainAxisAlignment.start,
              crossAxisAlignment: CrossAxisAlignment.start,
              children: [
                Row(
                  children: [
                    InkWell(
                      onTap: () {
                        onStateChange();
                      },
                      child: Container(
                          padding: EdgeInsets.only(
                            top: 10,
                            left: 15,
                            bottom: 5,
                            right: 10,
                          ),
                          child: Icon(
                            Icons.check_circle_rounded,
                            color: isActiveStatus
                                ? secondaryColor != null
                                    ? secondaryColor
                                    : Colors.greenAccent
                                : AppColors.APP_GRAY_1,
                          )),
                    ),
                    Container(
                      padding: EdgeInsets.only(
                        top: 10,
                        left: 15,
                        bottom: 5,
                        right: 10,
                      ),
                      child: Text(
                        cardStatus,

                        style:  textTheme.bodyText1.copyWith(
                          color: cardTextColor != null
                              ? cardTextColor
                              : Colors.black87,
                          fontSize: 16,
                          fontWeight: FontWeight.bold,
                          wordSpacing: 1,
                          letterSpacing: 1,
                        ),


                        softWrap: true,
                        maxLines: 2,
                      ),
                    ),
                  ],
                ),
                Container(
                  padding: EdgeInsets.only(
                    top: 5,
                    left: 66,
                    bottom: 5,
                    right: 5,
                  ),
                  //margin:EdgeInsets.all(2),
                  child: Text(
                    cardDesc,

                    style:  textTheme.bodyText1.copyWith(
                      color: cardTextColor != null
                          ? cardTextColor
                          : Colors.black87,
                      fontSize: 15,
                      fontWeight: FontWeight.normal,
                      wordSpacing: 1,
                      letterSpacing: 1,
                    ),
                    softWrap: true,
                    maxLines: 2,
                  ),
                ),
                Container(
                  padding: EdgeInsets.only(
                    top: 5,
                    left: 66,
                    bottom: 5,
                    right: 5,
                  ),
                  child: Text(
                    cardDate,

                    style:  textTheme.bodyText1.copyWith(
                      color: cardTextColor != null
                          ? cardTextColor
                          : Colors.black87,
                      fontSize: 12,
                      fontWeight: FontWeight.normal,
                      wordSpacing: 1,
                      letterSpacing: 1,
                    ),
                    softWrap: true,
                    maxLines: 2,
                  ),
                ),
              ],
            ),
          ));
    } else if (notesCard) {
      if (cardDesc.length > 50) {
        firstHalf = cardDesc.substring(0, 50);
        secondHalf = cardDesc.substring(50, cardDesc.length);
      } else {
        firstHalf = cardDesc;
        secondHalf = "";
      }
      return Card(
        child: Container(
          padding: new EdgeInsets.symmetric(horizontal: 5.0, vertical: 5.0),
          child: secondHalf.isEmpty
              ? Container(
                  height: height,
                  child: Column(
                    children: [
                      Row(
                        children: [
                          Container(
                              padding: EdgeInsets.only(
                                top: 10,
                                left: 15,
                                bottom: 5,
                                right: 10,
                              ),
                              child: Icon(Icons.sticky_note_2_rounded,
                                  size: 20,
                                  color: secondaryColor != null
                                      ? secondaryColor
                                      : Colors.greenAccent)),
                          Container(
                            alignment: Alignment.topLeft,
                            padding: EdgeInsets.only(
                              top: 10,
                              left: 10,
                              right: 20,
                              //bottom: 10,
                            ),
                            child: Text(
                              cardAuthor,

                              style:  textTheme.bodyText1.copyWith(
                                color: cardTextColor != null
                                    ? cardTextColor
                                    : Colors.black87,
                                fontSize: 18,
                                fontWeight: FontWeight.bold,
                                wordSpacing: 1,
                                letterSpacing: 1,
                              ),

                              textAlign: TextAlign.center,
                              softWrap: true,
                              maxLines: 2,
                            ),
                          ),
                        ],
                      ),
                      Container(
                          padding: EdgeInsets.all(10),
                          alignment: Alignment.topLeft,
                          child: new Text(
                            firstHalf,
                            textAlign: TextAlign.start,


                            style:  textTheme.bodyText1.copyWith(
                              color: cardTextColor != null
                                  ? cardTextColor
                                  : Colors.black87,
                              fontSize: 14,
                              fontWeight: FontWeight.normal,
                              wordSpacing: 1,
                              letterSpacing: 1,
                            ),


                            //softWrap: true,
                            //maxLines: 2,
                          )),
                      Container(
                        alignment: Alignment.topLeft,
                        padding: EdgeInsets.only(
                          //   top: 10,
                          left: 10,
                          right: 40,
                          bottom: 10,
                        ),
                        child: Text(
                          cardDate,

                          style:  textTheme.bodyText1.copyWith(
                            color: cardTextColor != null
                                ? cardTextColor
                                : Colors.black87,
                            fontSize: 12,
                            fontWeight: FontWeight.normal,
                            wordSpacing: 1,
                            letterSpacing: 1,
                          ),
                          textAlign: TextAlign.center,
                          softWrap: true,
                          maxLines: 2,
                        ),
                      ),
                    ],
                  ),
                )
              : new Column(
                  children: <Widget>[
                    Row(
                      children: [
                        Container(
                            padding: EdgeInsets.only(
                              top: 10,
                              left: 15,
                              bottom: 5,
                              right: 10,
                            ),
                            child: Icon(Icons.sticky_note_2_rounded,
                                size: 20,
                                color: secondaryColor != null
                                    ? secondaryColor
                                    : Colors.greenAccent)),
                        Container(
                          alignment: Alignment.topLeft,
                          padding: EdgeInsets.only(
                            top: 10,
                            left: 10,
                            right: 20,
                            //bottom: 10,
                          ),
                          child: Text(
                            cardAuthor,

                            style:  textTheme.bodyText1.copyWith(
                              color: cardTextColor != null
                                  ? cardTextColor
                                  : Colors.black87,
                              fontSize: 18,
                              fontWeight: FontWeight.bold,
                              wordSpacing: 1,
                              letterSpacing: 1,
                            ),
                            textAlign: TextAlign.center,
                            softWrap: true,
                            maxLines: 2,
                          ),
                        ),
                      ],
                    ),
                    Container(
                        padding: EdgeInsets.all(10),
                        child: new Text(
                          flag ? (firstHalf + "...") : (firstHalf + secondHalf),
                          style:  textTheme.bodyText1.copyWith(
                            color: cardTextColor != null
                                ? cardTextColor
                                : Colors.black87,
                            fontSize: 14,
                            fontWeight: FontWeight.normal,
                            wordSpacing: 1,
                            letterSpacing: 1,
                          ),
                        )),
                    Container(
                      padding: EdgeInsets.only(
                        //top: 10,
                        left: 10,
                        right: 20,
                        bottom: 10,
                      ),
                      child: new Row(
                        mainAxisAlignment: MainAxisAlignment.spaceBetween,
                        children: <Widget>[
                          Container(
                            alignment: Alignment.center,
                            padding: EdgeInsets.only(
                              //   top: 10,
                              //left: 10,
                              right: 20,
                              bottom: 10,
                            ),
                            child: Text(
                              cardDate,
                              style:  textTheme.bodyText1.copyWith(
                                color: cardTextColor != null
                                    ? cardTextColor
                                    : Colors.black87,
                                fontSize: 12,
                                fontWeight: FontWeight.normal,
                                wordSpacing: 1,
                                letterSpacing: 1,
                              ),
                              textAlign: TextAlign.center,
                              softWrap: true,
                              maxLines: 2,
                            ),
                          ),
                          InkWell(
                            onTap: () {
                              onStateChange();
                            },
                            child: Container(
                              alignment: Alignment.center,
                              padding: EdgeInsets.only(
                                //   top: 10,
                                left: 10,
                                right: 20,
                                bottom: 10,
                              ),
                              child: Text(
                                flag ? "Show More" : "Show Less",
                                style:  textTheme.bodyText1.copyWith(
                                  color: cardTextColor != null
                                      ? cardTextColor
                                      : Colors.black87,
                                  fontSize: 11,
                                  fontWeight: FontWeight.bold,
                                  wordSpacing: 1,
                                  letterSpacing: 1,
                                ),
                                textAlign: TextAlign.center,
                                softWrap: true,
                                maxLines: 2,
                              ),
                            ),
                          ),
                        ],
                      ),
                    ),
                  ],
                ),
        ),
      );
    } else if (isModuleCard) {
      if (isGrid) {
        return Card(
          color: isEnabled ? cardColor : Colors.grey,
          elevation: elevation,
          shape: shape,
          child: Stack(
            children: <Widget>[
              Visibility(
                visible: isVisible,
                child: Align(
                  alignment: Alignment.topCenter,
                  child: Container(
                    margin: EdgeInsets.only(top: 15),
                    child: SvgPicture.asset(
                      sourceImage,
                      width: 35,
                      height: 35,
                    ),
                  ),
                ),
              ),
              Align(
                alignment:
                    isVisible ? Alignment.bottomCenter : Alignment.center,
                child: Column(
                  crossAxisAlignment: CrossAxisAlignment.stretch,
                  verticalDirection: VerticalDirection.up,
                  children: <Widget>[
                    Container(
                      padding: EdgeInsets.all(10),
                      decoration: BoxDecoration(
                        /* gradient: LinearGradient(
                                  colors: [Colors.deepOrange, Colors.yellow],
                                  stops: [0.0, 0.7],
                                ),*/
                        color: isEnabled
                            ? Colors.white.withOpacity(0.4)
                            : Colors.white,
                        borderRadius: BorderRadius.only(
                            bottomLeft: Radius.circular(radius),
                            bottomRight: Radius.circular(radius)),
                      ),
                      alignment: Alignment.center,
                      child: Text(cardText, style: textStyle),
                    )
                  ],
                ),
              ),
            ],
          ),
        );
      } else {
        return Container(
          height: height,
          padding: EdgeInsets.all(padding),
          child: Card(
            color: cardColor,
            elevation: elevation,
            shape: shape,
            child: Row(
              children: <Widget>[
                Padding(
                  padding: EdgeInsets.all(10.0),
                  child: Container(
                    width: 50.0,
                    height: 50.0,
                    decoration: BoxDecoration(
                        color: cardTextColor,
                        image: DecorationImage(
                            image: NetworkImage(sourceImage),
                            fit: BoxFit.cover),
                        borderRadius: BorderRadius.all(Radius.circular(75.0)),
                        boxShadow: [
                          BoxShadow(blurRadius: 7.0, color: Colors.black)
                        ]),
                  ),
                ),
                Container(
                  padding: EdgeInsets.all(5.0),
                  child: Text(cardText,
                      style: textStyle.copyWith(
                        color: isEnabled
                            ? cardTextColor
                            : Colors.black.withOpacity(0.4),
                      )

                      /*TextStyle(
                        color: isEnabled
                            ? cardTextColor
                            : Colors.black.withOpacity(0.4),
                        fontSize: FontSize.FONT_14,
                        fontWeight: FontWeight.bold),*/
                      ),
                )
              ],
            ),
          ),
        );
      }
    } else {
      return Container(
        width: width,
        height: height,
        child: Card(
          shape: shape,
          color: cardColor,
          child: Container(
            padding: EdgeInsets.all(padding),
            margin: EdgeInsets.all(padding),
            child: Text(
              cardText,

              style:  textTheme.bodyText1.copyWith(
                color: cardTextColor != null
                    ? cardTextColor
                    : Colors.black87,
                fontSize: 14,
                fontWeight: FontWeight.normal,
                wordSpacing: 1,
                letterSpacing: 1,
              ),

            ),
          ),
          elevation: elevation,
        ),
      );
    }
  }

  void _setCardSize() {
    if (cardSize == CardSize.small) {
      padding ??= mini ? 5.0 : 6.0;
      width ??= 160;
      height ??= 100;
      fontSize = 15.0;
      imageSize = mini ? 34.0 : 40.0;
    } else if (cardSize == CardSize.medium) {
      padding ??= mini ? 5.5 : 6.5;
      width ??= 220;
      height ??= 150;
      fontSize = 17.0;
      imageSize = mini ? 40.0 : 46.0;
    } else {
      padding ??= mini ? 6.0 : 7.0;
      width ??= 250;
      height ??= 180;
      fontSize = 19.0;
      imageSize = mini ? 46.0 : 52.0;
    }
  }

  void _createStyle(BuildContext context) {
    final textTheme = Theme.of(context).textTheme;
    switch (cardType) {
      case CardType.customCard:
        cardText ??= 'Okay';
        cardTextColor ??= Colors.black87;
        cardColor ??= Colors.white;
        textStyle ??= textTheme.bodyText1.copyWith(
            fontWeight: FontWeight.bold,
            fontSize: 15,
            letterSpacing: 1,
            color: AppColors.appWhite);
        break;
      case CardType.cardWithTitle:
        cardTitle ??= "Title";
        cardName ??= "Name Harish";
        cardText ??= 'Okay';
        cardTextColor ??= Colors.black87;
        cardColor ??= Colors.white;
        textStyle ??= textTheme.bodyText1.copyWith(
            fontWeight: FontWeight.bold,
            fontSize: 15,
            letterSpacing: 1,
            color: AppColors.appWhite);
        break;

      case CardType.cardWithDashBoard:
        shape ??= RoundedRectangleBorder(
          borderRadius: BorderRadius.circular(15.0),
        );
        cardTitle ??= "Harish";
        cardName ??= "Aagnia technologies";
        cardText ??= 'Okay';
        statusTag ??= '#tag';
        cardTextColor ??= Colors.black87;
        cardColor ??= Colors.white;
        textStyle ??= textTheme.bodyText1.copyWith(
            fontWeight: FontWeight.bold,
            fontSize: 15,
            letterSpacing: 1,
            color: AppColors.appWhite);
        break;

      case CardType.cardDashBoardDeal:
        shape ??= RoundedRectangleBorder(
          borderRadius: BorderRadius.circular(15.0),
        );
        cardTitle ??= "Deals Created";
        cardPrice ??= "117";
        cardPercentage ??= '66';
        cardDate ??= "(Dec 2020)";
        trendValue ??= true;
        cardTextColor ??= Colors.black87;
        cardColor ??= Colors.white;
        textStyle ??= textTheme.bodyText1.copyWith(
            fontWeight: FontWeight.bold,
            fontSize: 15,
            letterSpacing: 1,
            color: AppColors.appWhite);
        break;

      case CardType.cardTask:
        shape ??= RoundedRectangleBorder(
          borderRadius: BorderRadius.circular(15.0),
        );
        cardStatus ??= "Open";
        cardDesc ??= "Sharing the business proposal";
        cardDate ??= "05-05-2021";
        cardTextColor ??= Colors.black87;
        cardColor ??= Colors.white;
        textStyle ??= textTheme.bodyText1.copyWith(
            fontWeight: FontWeight.bold,
            fontSize: 15,
            letterSpacing: 1,
            color: AppColors.appWhite);
        break;

      case CardType.cardNotes:
        shape ??= RoundedRectangleBorder(
          borderRadius: BorderRadius.circular(15.0),
        );
        cardAuthor ??= "Name";
        cardDesc ??=
            "They are ok with the solution, but need to review on budget";
        cardDate ??= "05-05-2021";
        cardTextColor ??= Colors.black87;
        cardColor ??= Colors.white;
        textStyle ??= textTheme.bodyText1.copyWith(
            fontWeight: FontWeight.bold,
            fontSize: 15,
            letterSpacing: 1,
            color: AppColors.appWhite);
        break;

      case CardType.cardWithImageAndText:
        shape ??= RoundedRectangleBorder(
          borderRadius: BorderRadius.circular(15.0),
        );
        cardText ??= "Name";
        cardTextColor ??= Colors.black87;
        cardColor ??= Colors.white;
        padding ??= 5;
        borderRadius ??= 15.0;
        gradientColor ??= [Colors.lightBlue, Colors.blue.shade300];
        sourceImage ??= SvgPictures.DOG;
        height ??= 100;
        width ??= 100;
        isVisible ??= true;
        isEnabled ??= true;
        radius ??= 15;
        isGrid ??= true;
        textStyle ??= textTheme.bodyText1.copyWith(
            fontWeight: FontWeight.bold,
            fontSize: 15,
            letterSpacing: 1,
            color: AppColors.appWhite);
        break;
    }
  }
}
