library bui_component;

import 'package:bui_component/Constants/AppColors.dart';
import 'package:bui_component/Constants/AppStrings.dart';
import 'package:bui_component/Constants/fontSize.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

class BUIIOSAlertBox {
  static Future showBUIIOSAlertBox({
    BuildContext context,
    Widget enterWidget,
    String type,
    bool isPositiveEnabled,
    bool isNegativeEnabled = false,
    Color positiveButtonColor,
    Color positiveButtonTextColor,
    Function() setPositiveAction,
  }) {
    assert(context != null, "context is null!!");
    assert(type != null, "Type is null!!");
    assert(enterWidget != null, "willDisplayWidget is null!!");

    /* showCupertinoDialog(
      context: context,
      builder: (BuildContext context) => CupertinoAlertDialog(
        title: const Text('Card is clicked.'),
        actions: <Widget>[
          CupertinoDialogAction(
            child: const Text('ok'),
            onPressed: () {
              Navigator.pop(context, 'ok');
            },
          ),
        ],
      ),
    );*/
    return showCupertinoDialog(
        context: context,
        builder: (context) {
          return CupertinoAlertDialog(
            title: Text(
              type ?? 'Warning!!',
              textAlign: TextAlign.center,
              style: TextStyle(
                  fontWeight: FontWeight.w900,
                  fontSize: FontSize.FONT_20,
                  color: AppColors.APP_COLOR_BLACK),
            ),
            /*shape: RoundedRectangleBorder(
              borderRadius: BorderRadius.all(Radius.circular(15)),
            ),*/
            //backgroundColor: Colors.white,
            actions: <Widget>[
              isNegativeEnabled ? CupertinoDialogAction(
                textStyle:  TextStyle(color: positiveButtonTextColor),
                child: Text(AppStrings.cancel),
                onPressed: () {
                  Navigator.pop(context, 'ok');
                },
              ): Container(),

              isPositiveEnabled ? CupertinoDialogAction(
                isDefaultAction: true,
                textStyle:  TextStyle(color: positiveButtonTextColor),
                child: Text(AppStrings.okay,style: TextStyle(color: positiveButtonTextColor),),
                onPressed: () {
                  setPositiveAction();
                  Navigator.pop(context, 'ok');
                },
              ): CupertinoDialogAction(
                textStyle:  TextStyle(color: positiveButtonTextColor),
                child: Text(AppStrings.okay,style: TextStyle(color: positiveButtonColor),),
                onPressed: () {
                  setPositiveAction();
                  Navigator.pop(context, 'ok');
                },
              )
            ],
            content: Column(mainAxisSize: MainAxisSize.min, children: <Widget>[
              enterWidget,
              /*SizedBox(
                height: 20,
              ),
                Row(
                mainAxisAlignment: MainAxisAlignment.center,
                crossAxisAlignment: CrossAxisAlignment.center,
                children: [
                  isNegativeEnabled
                      ? Button.mini(
                          width: MediaQuery.of(context).size.width * 0.15,
                          onPressed: () {
                            Navigator.of(context).pop();
                          },
                          buttonSize: ButtonSize.medium,
                          buttonType: ButtonType.custom,
                          btnColor: AppColors.APP_BUTTON_GREY,
                          btnTextColor: positiveButtonColor,
                          btnText: AppStrings.cancel,
                          elevation: 10,
                        )
                      : Container(),
                  isNegativeEnabled
                      ? SizedBox(
                          width: 30,
                        )
                      : Container(),
                  isPositiveEnabled
                      ? Button.mini(
                          width: MediaQuery.of(context).size.width * 0.1,
                          onPressed: () {
                            setPositiveAction();
                            Navigator.of(context).pop();
                          },
                          buttonSize: ButtonSize.medium,
                          buttonType: ButtonType.custom,
                          btnColor:
                              positiveButtonColor ?? AppColors.errorWarning,
                          btnTextColor: AppColors.appWhite,
                          btnText: AppStrings.okay,
                          elevation: 10,
                        )
                      : Button.mini(
                          width: MediaQuery.of(context).size.width * 0.1,
                          onPressed: () {
                            setPositiveAction();
                            Navigator.of(context).pop();
                          },
                          buttonSize: ButtonSize.medium,
                          buttonType: ButtonType.custom,
                          btnColor:
                              positiveButtonColor ?? AppColors.errorWarning,
                          btnTextColor: AppColors.appWhite,
                          btnText: AppStrings.okay,
                          elevation: 10,
                        )
                ],
              ),*/
            ]),
            // elevation: 1,
          );
        });
  }
}
